#ifndef typmod_included
#define typmod_included 1
#ifndef  NOSTATVER
static char cvsid_typmod[]="@(#) Anacad $Id: typmod.h,v 1.49 2003/10/17 13:12:20 joelb Exp $"; /* %Z%%M% %I% %E% Anacad */
#endif
/*------------------------------------------------------------*/
/*                 ANACAD COMPUTER SYSTEM                     */
/*            COPYRIGHT                1990                   */
/*------------------------------------------------------------*/
/*                                                            */
/*     name : typmod.h      |      release :                  */
/* language :  C            |      version : %I%              */
/*     date : %D%      |      author  :                  */
/*                                                            */
/*------------------------------------------------------------*/
/*                                                            */
/* parameters                                                 */
/* ==========                                                 */
/*                                                            */
/*  name   type  IN/OUT              function                 */
/*                                                            */
/*                                                            */
/*------------------------------------------------------------*/
/*                                                            */
/* modifications                                              */
/* =============                                              */
/*                                                            */
/*  date                             function                 */
/*                                                            */
/*------------------------------------------------------------*/

#include <stdio.h>
#include <ctype.h>
#include <math.h>

#include "machine.glob"
/* pour test param de modeles et geometries: must be the same than in ficou.c
 */
#define  UNDEF   (-0.9765439e20) 
#define  NOSPEC  (-1.49231e20)  /* pour affecter */
#define max133 3000

/* predefined macros... */
#define sqr(a)  a * a
/* predefined constants... */
#define C_ORD_CHAR 256
#define C_ORD_BOOL 1
#define true 1
#define false 0
#define vrai 1
#define VRAI 1
#define faux 0
#define FAUX 0
#define DO do
#define IF if
#define ELSE else
#define WHILE while
#define FOR for
#define SWITCH switch
#define CASE case
#define DEFAULT default
#define maxint 0x7FFFFFFF
/* ------------------------ */


#define reftmp  300.15e0
#define tnomref  273.15e0
#define d1p16  1.16e0
#define d7p02dm4  7.02e-4
#define d1108  1108.0e0
#define tordu1  4.342944819e0
#define tordu2  159154943.0e0
#define d1p0p6  1.0e+6
#define d1p0p9  1.0e+9
#define d1p0p4  1.0e+4
#define d1000  1000.0e0
#define d1p9  1.9e0
#define d360  360.0e0
#define d200  200.0e0
#define d180  180.0e0
#define d100  100.0e0
#define d90  90.0e0
#define d50  50.0e0
#define d20  20.0e0
#define d10p0  10.0e0
#define d60  60.0e0
#define d5m4  0.0005e0
#define d160  160.0e0
#define d5m2  0.05e0
#define d9  9.0e0
#define d2p1  0.2e0
#define d5m3  0.005e0
#define d300  300.0e0
#define d0p04  0.04e0
#define d0p4  0.4e0
#define d5m5  0.00005e0
#define d9p9  9.9e0
#define d5p0  5.0e0
#define d4p0  4.0e0
#define d3p0  3.0e0
#define d1p5m3  1.5e-3
#define d1m20  1.0e-20
#define d2p5  2.5e0
#define d2p0  2.0e0
#define d1p8  1.8e0
#define d1p58m7  1.58e-7
#define d1p5  1.5e0
#define d1p25  1.25e0
#define d1p2  1.2e0
#define d1p125  1.125e0
#define d1p0  1.0e0
#define d0p9  0.9e0
#define d0p6  0.6e0
#define d0p5  0.5e0
#define d0p25  0.25e0
#define d0p75  0.75e0
#define d0p1  0.1e0
#define d0p02  0.02e0
#define d0p049  0.049e0
#define d1p7  1.7e0
#define d1m2  1.0e-2
#define d1m3  1.0e-3
#define d1m4  1.0e-4
#define d1m12  1.0e-12
#define d1m6  1.0e-6
#define d1m9  1.0e-9
#define d1m10  1.0e-10
#define dzero  0.0e0
#define d10000  1.0e+4
#define d0p67  0.6666666667e0
#define d1p33  1.33333333e0
#define d1p67  1.666666667e0
#define d0p7  0.7e0
#define d0p8  0.8e0



/*These two numbers must be the same than in ficou.c */
#define m1d30   -1.9e24
#define p1d30 1.9e24

#define EME_DEV_FLG '"'

#ifndef MIN
#define MIN(a,b) ((a) < (b)?(a):(b))
#endif

#ifndef MAX
#define MAX(a,b) ((a) > (b)?(a):(b))
#endif

#define GUDM_NONE             0
#define GUDM_EQUASET          2
#define GUDM_EQUASET_UDM      3
#define GUDM_EQUASET_UDM_MKSA 4


#define RMOD_STD    1
#define RMOD_ST     2
#define RMOD_RCLINE 3
#define RMOD_ACC2   4
#define RMOD_TIMOD  5

#define CMOD_STD    1
#define CMOD_ST     2
#define CMOD_UNUSED 3
#define CMOD_ACC2   4
#define CMOD_TIMOD  5

#define MERCK1       1
#define MERCK2       2
#define MERCK3       3
#define MERCK4       4
#define BERK1        5
#define BERK2        6
#define BERK3        7
#define BSIM1        8
#define TFT1         9
#define TFT2        10
#define BSIM2       11
#define HS12        12
#define HS13        13
#define MASTAR      14
#define AMS1        15
#define ELDO_ENH16  16
#define ELDO_ENH17  17 
#define STMOS1      18
#define STMOS3      19
#define MOSUDM1     20
#define ACM         21 /*definicao do valor da variavel do modelo ACM*/
#define MOSRST      40
#define STPROM1     41
#define STPROM3     42
#define STMOS4      43
#define EKV         44
#define MASTARNQS   45
#define MISNAN      46
#define BSIM3       47
#define CSEM        48
#define ACCMOS1     49
#define ACCMOS2     50
#define ACCMOS3     51
#define ACCBSIM1    52
#define BSIM3V3     53
#define MOTOROLA    54
#define BSIM3SOI    55
#define BSIM3SOIV2  56
#define MOSP9       59
#define BSIM4       60
#define EKV_V3      61
#define TFTSH       62
#define MM11        63
#define ASITFT      64
#define MM1100      65
#define HISIM       66
#define SPMOD       67
#define BSIM5       68
#define MM1102      69
#define PSPM        70
#define BTA_HVMOS1 101

#define SOI1       150
#define SOIRST     200

#define MAXLEVEL 200	 /* Arrays of model should not exceed 200 */


#define BERKBIP       1
#define STBIP         2
#define BNR_M_HICUM   3
#define MEXTRAM       4
#define CHERRY        5
#define QNWELL        6
#define ROCK_M_HICUM  7
#define VBIC          8
#define PUB_M_HICUM   9
#define BIPUDM1     10
#define BIPRST      20
/* #define VBIC115       21..  slot 21 available */
#define MEXTRAM504    22
#define MODELLA       23
#define PUB_M_HICUM0  24

#define BERKDIO   1
#define ELDIO2    2
#define TUNNELD   3
#define STDIO     4
#define STFOWL    5
#define STMIS     6
#define DNRF      7
#define JUNCAP    8
#define DPH500    9
#define DIOUDM1  10
#define DIORST   20
#define DIO21    21
#define JUNCAP2  22

#define NMOS_MHS           1
#define NMOS_ELDO_ENH17    2
#define NMOS_ELDOMOS_BERK2 3
#define NMOS_ELDOMOS_ALL   4
#define NMOS_PRECISE       5

#define BERKJFET    1
#define JFET2       2
#define JFETAS      3
#define STJFET1     4
#define STJFET2     5
#define ASCURTICE   6
#define ASSCHICH    7
#define ASSTATZ     8
#define ASTRIQUIT   9
#define JFETUDM1   10
#define JFETRST    20
#define JFETAUS    21

#define NODE_TK  1
#define NODE_DTK 2
#define NODE_TC  3
#define NODE_DTC 4

typedef char  *ptchar;

#define OFFSET_PARAM_NORM    0
#define OFFSET_SUP_PARAM     1
#define OFFSET_JUNCAP_PARAM  2
#define OFFSET_MBINNING      3
#define OFFSET_SUP_COMMON    4
#define OFFSET_AGED          5
#define OFFSET_WSUP_PARAM    6
#define OFFSET_WMBINNING     7
#define OFFSET_WSUP_COMMON   8
#define OFFSET_NVM           9
#define OFFSET_DP500_PARAM  10
#define OFFSET_WDP500_PARAM 11
#define OFFSET_MAX          11  /* same number than above.. */

/*--------------------------------------------------------------------
  MODEL STRUCTURE tymod, and associated variable modmos.   
         
  The tymod structure contains all the parameters which can be      
  specified in the .MODEL card, be it a MOS, BIPOLAR, DIODE  or JFET     
  model. Some parameters have synonyms, and some conversion factors can
  be applied. 

     - the genre character of the tymod structure is :
		"M" for a MOS transistor.
		"D" for a diode.
     - The noup character of the tymod structure is :
		"N" for a NMOS transistor.
		"P" for a PMOS transistor.
     - modname[i] is the name of the ith model.

     some synonyms:

     - VTO, VT0 loaded in vt0 of the tymod field.
     - CDIFS0, CJ  loaded  in cdifs0 of the tymod field.
     - CDIFP0, CJSW loaded in cdifp0 of the tymod field.
     - TOX, EOX loaded in eox of the tymod field.
     - THETA, TG loaded in tg of the tymod field.
     - NSUB, NB loaded in nsub of the tymod field.
     - VMAX,VL loaded in vl of the tymod field.
     - MU0, UO loaded in mu0 of the tymod field.
     - DPHIF, PHI loaded in dphif of the tymod field.
     - KO, KP loaded in ko of the tymod field.
     - dl of the tymod field contains or the DL value specified in the
       .MODEL card, or 2*LD if LD is specified in the .MODEL card.
     - KB, GAMMA loaded in kb of the tymod field.
     - LEVEL, NIV loaded in niv of the tymod field.

     Units conversion :

     - RSH, RD, and RS are converted in Kilo-ohms. Other values
       remain unchanged.

     - p1..p84 are dummy parameters which can be used to stored 
       any variable: parameter p1..p84 can be referred to in the 
       .MODEL card or associated to user defined parameter names.
--------------------------------------------------------------------*/
double safelog (double x)
	{
	if (x < 1e-40) return log(1e-40);

	else return log(x);

	}

double safesqrt (double x)
	{
	if (x < 1e-30) return sqrt(1e-30);

	else return sqrt(x);

	}

double safexp (double x)
	{
	if (x > 500) return exp(500);

	else return exp(x);

	}

typedef struct S_tymodinfo
{
  char *libname,*key_name,*key;
  char exten_wl; 
  char bool_included; 
  long ilinevlib;

  unsigned int from_crypted:    1;
} tymodinfo;

typedef struct S_tymod
{

  /* First part: Never assigned by user */
  double  unused,tempav, mktsurq,megfet,moldeg,moldvt;
  double vcrit,vlim,Dnf,Vzener,Vzenlim;

/* Second part: reserved names always put at that place */
  double  xqc,wmin,wdef,lmin,ldef,lmax,wmax,xlref,xwref,tempmin,tempmax; 
  double  xl,xw;
  double  temp,tnom,dtemp;
  double  scalem;
  double  scalel,scalew;
  double vt0,cox;
  double is,rb,re,rc,xcjc,rbm,ptf;

/* Free parameters */

  double  p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,
          p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32,p33,p34,p35,
          p36,p37,p38,p39,p40,p41,p42,p43,p44,p45,p46,p47,p48,p49,p50,
          p51,p52,p53,p54,p55,p56,p57,p58,p59,p60,p61,p62,p63,p64,p65,p66, 
          p67,p68,p69,p70,p71,p72,p73,p74,p75,p76,p77,p78,p79,p80;

  double  mu0,nsub,dphif,rdphif,ko,ko1,vl,gw,gl,
          kb,tg,kw,kl,nfs,eta,delta,
          kappa,isc,nc,irb,lambda,
          tr,cjs,vjs,mjs,xtb;
  double dmut,kb1,kb2,l0,n1,n2,nd,racc,tw,vc,recl;


/* Common approach... */
  double  eg,xti,kf,af; 
  double  rd,rs,rsh,nss,js; 
  double  tpg,eox,deltal,deltaw;


  double fc,cdifs0,cdifp0,cjc,mj,mjsw,tf,cje,vje,sh,
         ve,dinf,dw,dl,ke,ldif,xj,mje,itf,xtf,vtf,
         nf,vjc,mjc,rec,ise,ikf,ne,ikr,nr,bf,br,vear,vaf;

  double  cgso,cgdo,cgbo,ucrit,uexp,utra,neff,cbs,cbd,pb;
 
  double update,wd,ld,w,l;

  double  cp81,
          cp82,cp83,cp84,cp85,cp86,cp87,cp88,cp89,cp90,cp91,
          cp92,cp93,cp94,cp95,cp96,cp97,cp98,cp99;
  double cp100,cp101,cp102,cp103,cp104,cp105,cp106,cp107,cp108,
         cp109,cp110;
/* End of free parameter */

  char  genre,noup;long  niv,imoref,imorig; char subsn,vert,nvm; 
  long flicklev,thermlev;
  long bbonly; /* for Black-Box */

  char init_done,pre_init,Mopened; 
  char bb_init_temp; char deriv,Mavailable;
  char temp_updated; /* flag for temperature update */
  long eldomos; 
  char mos_deriv; /* 1 if analytical derivatives*/
  char mos_qbsd; /* 1 if Charges on bulk/source and Bulk/drain */
  char mos_dericap,mos_dcapabulk,analog,simulike,nqs,nqs_tran,
       equaset;
  char ccontrol,impact_ion,temp_node_unit,temp_node_typed,
       nqs_modeling, nqs_Gudm_ac_implementation;
  long nbintpins,ibulk; 

  unsigned int Mmksa:  1;
  unsigned int tabudm: 1;
  unsigned int ModZ: 1; /* SOI-like: can have High impedance node.. */
  unsigned int NOIFLAG: 1;
  unsigned int use_common_approach: 1;
  unsigned int tobeduped:      1;
  unsigned int tnom_specified: 1;
  unsigned int is_ics:         1;

  unsigned int read_courcb:    1;
  unsigned int gid_instp:      1;
  unsigned int xlconv:         1;
  unsigned int Mprotected:     1;
  unsigned int Mencrypted:     1;
  unsigned int bip_diode:      1;
  unsigned int fromdevx:       1;
  unsigned int subloc:         1; /* model local to a subckt.. */

  unsigned int nqs_ac_active:   1;
  unsigned int nqs_tran_active: 1;
  unsigned int OCI_modwl_sent:  1;
  unsigned int OCI_sent:        1;
  unsigned int OCI_dupname:     1;

  double inp_xl,inp_xw,inp_xlref,inp_xwref;

  double *sup_param;/* Additionnal parameters name for the model:
                       loaded by call to 
                       associate_param_devlev_extended */
  long sizesup; /* Used only for pre 5.1 versions.. */
  long maxsup;

  unsigned long add_param; /* For CFAS */

  double *juncap_param;    /* Hold juncap specific parameters.. */
  long max_juncap_param;

  double *dp500_param;    /* Hold dp500 specific parameters.. */
  long max_dp500_param;
  
  double *wdp500_param;    /* Hold dp500 specific parameters.. */
  long wmax_dp500_param;
  
  double *Mbinning;   /* Binning: allocated only if at least
                         one binning parameter is given in .MODEL 
                         card.. */
  long max_Mbinning;

  double *WMbinning; /* Working field for binning parameters */
  long max_WMbinning;

  double *sup_common,*w_sup_common; /* For additionnal array and
                                       working array for common approach */
  long max_sup_common, max_w_sup_common;

  /* Working sup_param */
  double *w_sup_param; long max_w_sup_param;

  double *Maged; long max_maged;
  double *nvm_parameter; long max_nvm_parameter;

  char **GN_names;
  char **GN_brnames;

  double **Vect_param;
  long max_vect_param,sz_vect_param;
  long sz_indiv;

  double **WVect_param;
  long max_wvect_param,sz_wvect_param;

  double *Xparam;
  long sz_Xparam;

  unsigned int mbol1:1;
  unsigned int mbol2:1;
  unsigned int mbol3:1;
  unsigned int mbol4:1;
  unsigned int mbol5:1;
  unsigned int mbol6:1;
  unsigned int mbol7:1;
  unsigned int mbol8:1;

  unsigned int mbol9:1;
  unsigned int mbol10:1;
  unsigned int mbol11:1;
  unsigned int mbol12:1;
  unsigned int mbol13:1;
  unsigned int mbol14:1;
  unsigned int mbol15:1;
  unsigned int mbol16:1;

  unsigned int mbol17:1;
  unsigned int mbol18:1;
  unsigned int mbol19:1;
  unsigned int mbol20:1;
  unsigned int mbol21:1;
  unsigned int mbol22:1;
  unsigned int mbol23:1;
  unsigned int mbol24:1;

  unsigned int mbol25:1;
  unsigned int mbol26:1;
  unsigned int mbol27:1;
  unsigned int mbol28:1;
  unsigned int mbol29:1;
  unsigned int mbol30:1;
  unsigned int mbol31:1;
  unsigned int mbol32:1;

  char *subext_name,*modname; long Mlgmodname; 
  long imocp,oci_eval_transio,indtmodel;
  long ix0; /* First X instance which has created that model..*/
  long mcurix; /* For private M: the X instance.. */ 
  long oci_xidx;
  tymodinfo *modinfo; 
  void *Mfrominst; /* Model created from M(pname) on instance..*/
  } tymod ;



/*--------------------------------------------------------------------
 TRANSISTOR STRUCTURE tytra and the trans variable.

 The following examples will be helpfull to understand this structure:

 ex1: MDF1 2 1 3 4 MOD1 W=10u L=2u AD=2p AS=1.5p PD=2u PS=3p NRD=1 NRS=2

 ex2: DO1 3 4 MODIODE 2.6


 All components are stored in a tytra stucture in the trans table. 
  
  - nomt is the name of the component : MDF1 and DO1 in our examples.
  - neep is a character:
      B if the component is a Bipolar,
      M if the component is a MOS,
      m if the component is a SOI MOS,
      D if the component is a diode,
      J if the component is a JFET,
      R if the component is a resistor,
      C if the component is a capacitor,
      L if the component is a Inductor,
      I if the component is a current injector,
      V if the component is a voltage source, and so on.

  - imo is the index of the tymod structure in the modmos table of the model 
    to which belongs the component in case of a bipolar, diode, JFET or MOS. 
    For instance in example ex1 imo will be the index of model MOD1 and of
    model MODIODE in ex2.
 
  - For a MOS:

       ng is the gate node. Here ng is node 2.
       nb is the bulk node. Here nb is node 4
       n1 and n2 are the two other pins according to the following rule:
          Mxx n2 ng n1 nb MODNAME.
       Then n1 will be node 3 and n2 will be node 1. This means that n2
       is the topological drain (as defined in the users's manual) and n1
       is the topological source. Be carefull not to get confused with the
       electrical meanings of drain and source although n1 is usually the 
       electrical source and n2 usually the electrical drain.

       wd is the channel width, in Microns. Here wd = 10
       ld is the channel length, in Microns. Here ld = 2
       ad is the area of the pin n2 in Micron**2. Here ad = 2.
       as is the area of the pin n1 in Micron**2. Here as = 1.5.
       pd is the junction perimeter at pin n2 in Microns. Here pd = 2.
       ps is the junction perimeter at pin n1 in Microns. Here ps = 3.
       nrd is the number of squares at pin n2. Here nrd = 1.
       nrs is the number of squares at pin n1. Here nrs = 2.

  - for a DIODE:
     
      ad contains the perimeter AREA given in the input deck. Here ad = 2
      ng is the first node, n1 the second node specified in the input
      deck. Here ng = "3" and n1 = "4".
--------------------------------------------------------------------*/
typedef struct S_tytra 
{
  double  wd,ld,ad,as,pd,ps,nrd,nrs; /* beware to modifiy 
                                        tabudm.h and misnanc.c in case that order is
                                        changed: 
                                        also see tyR,tyBJT,tyDIO,tyJFET,tyCap.
                                        Only ANACAD may change that field. */
  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int ad_given:1;
  unsigned int as_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int nrd_given:1; 
  unsigned int nrs_given:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int dev_f_call: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;
  
} tytra;

typedef struct S_tyR /* Same size than S_tytra */
{
  /* This structure cannot be modified unless in synch with tytra above */
  double  R,Ilast,tc1,tc2,onR,Rorig,WCR,ditra; 
  long  imodr,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int tc1_given:1;
  unsigned int tc2_given:1;
  unsigned int is_rbm:1;
  unsigned int opt:1;
  unsigned int tc3_given:1; 
  unsigned int nrs_given:1;

  unsigned int Tinit_done:1;
  unsigned int Rport:1;
  unsigned int rflick:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem3: 1;
  unsigned int tequaspi: 1;
} tyR;

typedef struct S_tyC /* Same size than S_tytra */
{
  /* This structure cannot be modified unless in synch with tytra above */
  double  C,Ilast,Corig,area,peri_qC,last_qC,uC,memc_iem; 
  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int tc1_given:1;
  unsigned int tc2_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int tc3_given:1; 
  unsigned int dccut:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;

} tyC;

typedef struct S_tyHC /* Same size than S_tytra */
{
  /* This structure cannot be modified unless in synch with tytra above */
  double  C,Ilast,Corig,area,QC,LQC,uc1,uc2; 
  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int tc1_given:1;
  unsigned int tc2_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int tc3_given:1; 
  unsigned int nrs_given:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int qcvpoly:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;


} tyHC;

typedef struct S_tyL /* Same size than S_tytra */
{
  /* This structure cannot be modified unless in synch with tytra above */
  double  L,Ilast,Lorig,nwiter,flux,fluxlast,Lunused1,meml_iem; 
  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int tc1_given:1;
  unsigned int tc2_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int tc3_given:1; 
  unsigned int dcfeed:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;

} tyL;



typedef struct S_tyBJT 
{
/* This structure cannot be modified unless in synch with tytra above */
  double  GPI,GMU,area,areab,
          GO,areac,qbx,qqbx; 
  long  imo,iaff,otix;  
  long  nb,ne,nc,ns; 
  char * nomt; 
  char  neep;

  unsigned int OFF:1;
  unsigned int rc_rbm:1;
  unsigned int ramp_stat:1;
  unsigned int rb_rbm:1;
  unsigned int ramp_stat2:1;
  unsigned int areas_given:1;
  unsigned int ramp_stat3:1; /* mixed */
  unsigned int ramp_stat4:1;

  unsigned int Tinit_done:1;
  unsigned int area_given:1;
  unsigned int modwl:1;
  unsigned int areab_given: 1;
  unsigned int areac_given: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;

} tyBJT;

typedef struct S_tySW 
{
/* This structure cannot be modified unless in synch with tytra above */
  double  s_ron,s_cgate,s_csat,s_vt,
          s_vh,s_palp,s_early,mem_alp; 
  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int s_type:1;
  unsigned int l_given:1;
  unsigned int ad_given:1;
  unsigned int as_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int nrd_given:1; 
  unsigned int nrs_given:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;

} tyS;

typedef struct S_tyDIO
{
 /* This structure cannot be modified unless in synch with tytra above */
  double  peri,cdfn_ox,area,log_area_is,area_work,log_area_isr,
          unused2,unused3; 
  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int OFF:1;
  unsigned int l_given:1;
  unsigned int ramp_used:1;
  unsigned int rb_rbm:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int nrd_given:1; /* mixed */
  unsigned int nrs_given:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;


} tyDIO;

typedef struct S_tyJFET /* Same size than S_tytra */
{
  /* This structure cannot be modified unless in synch with tytra above */
  double  JW,JL,area,last_vgs,pnvgs,pnvgd,qgs_ckiter,qgd_ckiter; 
  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int OFF:1;
  unsigned int l_given:1;
  unsigned int area_given:1;
  unsigned int as_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int JW_given:1; 
  unsigned int JL_given:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;

} tyJFET;

typedef struct S_tyF /* Same size than S_tytra */
{
  /* This structure cannot be modified unless in synch with tytra above */
  double  Fval,Ilast,Fval_last,nwiter,unused,unused2,Fsee,Fw; 
  long  imo,iaff,otix;  
  long  ytra,n1,n2,nwlig; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int ad_given:1;
  unsigned int as_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int nrd_given:1; 
  unsigned int chaipi:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;


} tyF;

typedef struct S_tyI /* Same size than S_tytra */
{
  /* This structure cannot be modified unless in synch with tytra above */
  double  Ival,Ilast,Ival_last,unused,unused2,unused3,inoise,ychron; 
  long  imo,iaff,otix;  
  long  ytra,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int ad_given:1;
  unsigned int as_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int nrd_given:1; 
  unsigned int nrs_given:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;


} tyI;


typedef struct S_tyFAS 
{
  double  dnbstates,
          dimacro,
          dimod,
          dnbusep,
          dnbpari,
          smpt,
          dfasinst,
          fnextevt; 

  long  imo,iaff,otix;  
  long  ng,n1,n2,nb; 
  char * nomt; 
  char  neep;

  unsigned int w_given:1;
  unsigned int l_given:1;
  unsigned int ad_given:1;
  unsigned int as_given:1;
  unsigned int pd_given:1;
  unsigned int ps_given:1;
  unsigned int nrd_given:1; 
  unsigned int nrs_given:1;

  unsigned int Tinit_done:1;
  unsigned int mostosw:1;
  unsigned int modwl:1;
  unsigned int derimeas: 1;
  unsigned int rs_created: 1;
  unsigned int rd_created: 1;
  unsigned int compute_resi: 1;
  unsigned int twork:1;

  unsigned int iem_isee: 1;
  unsigned int rtf: 1;
  unsigned int compad: 1;
  unsigned int devline: 1;
  unsigned int tfree1: 1;
  unsigned int emul_oci: 1;
  unsigned int trsem: 1;
  unsigned int tequaspi: 1;


} tyFAS;

/*--------------------------------------------------------------------
 tygeo structure and trageo variable.
 Like the tytra structure, one tygeo structure is allocated for each
 MOS transistor or diode of the netlist.
 the tygeo structure contains dummy parameters which can be used
 to store values which do not change with bias, but which can 
 depend on geometries of the component, unlike parameter of the
 tymod field which can NOT depend on geometries since they must be
 valid for all the transistors refering to this model.
 However, q11, qq1, q22, qq2, qg, qqg, qbb, qqb are reserved to store
 dynamic contributions.  
--------------------------------------------------------------------*/

typedef struct S_tygeo{
  /* If this field is modified, also modify above 
     tywbjt, tywdio and tywjfet: must be done by ANACAD */
  double  qqg,qq2,qq1,qqb,qg,q22,q11,qbb; 
  double  fn,td,ggm,gm,kb1,m0; 
  double  gad,gas,gpd,gps; 
  } tygeo ;

typedef struct S_tywBJT{
  /* this field cannot be modified unless S_tygeo above modified */
  double  qqxs,qqbc,qqbe,qqbext,qxs,qbc,qbe,qbext; 
  double  GM,log_area_js,log_area_ise,log_area_is,qbc_ckiter,qbe_ckiter; 
  double  ics,log_area_isc,log_ibe,log_ibc; 
  } tywBJT ;

typedef struct S_tywJFET{
  /* this field cannot be modified unless S_tygeo above modified */
  double  qqg,qqgd,qqgs,curr_vgs,qg,qgd,qgs,w2; 
  double  w3,gds,w4,gm,w5,w6; 
  double  ggd,ggs,igd,igs; 
  } tywJFET ;

/*--------------------------------------------------------------------
 tybsim structure and trabsim variable.
 the tybsim structure contains parameters used for the
 second BSIM model bsim1 (level 8) . This parameters are
 in fact the model parameters after having taken into account
 the geometries.
 for example if VFB, LVFB and WVFB are model parameters, the
 vfb field will be used to store
    vfb = VFB + LVFB / T->ld + WVFB / T->wd .
--------------------------------------------------------------------*/

typedef struct S_tybsim1 {
double vfb,phi,k1,k2,eta0,etaB,etaD,beta0,beta0B;
double ugs,ugsb,uds,udsb,udsd,betavdd,betavddb,betavddd;
double subslop,subslopb,subslopd,WLCox;
} tybsim1;

/*--------------------------------------------------------------------
 tybsim structure and trabsim variable.
 the tybsim structure contains parameters used for the
 second BSIM model bsim2 (level 11) . This parameters are
 in fact the model parameters after having taken into account
 the geometries.
 for example if VFB, LVFB and WVFB are model parameters, the
 vfb field will be used to store
    vfb = VFB + LVFB / T->ld + WVFB / T->wd .
--------------------------------------------------------------------*/

typedef struct S_tybsim{
  double vfb,phi,k1,k2,eta0,etaB,beta0,beta0B,betas0,betasB,beta20;
  double beta2B,beta2G,beta30,beta3B,beta3G,beta40,beta4B,beta4G;
  double CoxWoverL,ua0,uaB,ub0,ubB,u10,u1B,u1D,n0,nB,nD;
  double vof0,vofB,vofD,ai0,aiB,bi0,biB,vghigh,vglow,CoxWL,CoxWLover3;
  double TwoCoxWLover3,CGSO,CGDO,CGBO,SqrtPhi,Phis3,Arg ;
} tybsim ;

/*--------------------------------------------------------------------
 tymossup structure.
 This structure contains the following information extracted from the
 MOS instantiation:

 Area is the Multiplier Factor M. M can be used to simulate the behavior
 of M identical MOS in parallel.
 rdc and rsc are source ad drain resistances which can be used also
 in the total source and drain resistance. These resistances are used
 for instance for level 12 and 13.
 
 ex: M1 1 2 3 4 MNAME W = 10U L = 2U M = 2 RDC = 10 RSC = 10
 
 in this case: Area = 2 rdc = 10 rsc = 10.
--------------------------------------------------------------------*/

#define NQS_UNDEF 0
#define NQS_NO    1
#define NQS_OK    2

typedef struct S_tymossup
{
  double Area;
  double rdc,rsc;
  double geo; /* for ARLEV = 3 */
  long ns; /* Number in Serie */
                                     /* beware to modifiy 
                                        tabudm.h and misnanc.c in case that order is
                                        changed */
  char nqs; /* NQS_OK,NQS_NO,NQS_UNDEF */

  unsigned int rdc_given:1;
  unsigned int rsc_given:1;
  unsigned int geo_given:1;

} tymossup;

typedef struct S_tymemfast
{
  double xias,xiad;
  double xrd,xrs;
  double gad,gas,gpd,gps;
} tymemfast;

/*********************************
*
* For bipolar devices: case of PTF
*
*************************************/

typedef struct S_bipmem
{
  double bip1,bip2,bip3; 
  /*double q1,q2;*/
  double qbx_ckiter;
  double pnvcs,pnvbc,pnvbe;
  long nbext;
} tybip;
typedef struct S_bipmem *ptbipmem;

/*******************************
*
* Field for non-quasi-static model: allocated in
* AC only.
*
************************************************/

typedef struct S_tynqscc
{
  double Mcdd,Mcdg,Mcds,Mcdb,
         Mcgd,Mcgg,Mcgs,Mcgb,
         Mcsd,Mcsg,Mcss,Mcsb;
} typcc;

typedef struct S_tynqsncc
{
  double Mcg1,Mcg2,Mcgb,Mc1b,Mc2b;
} typncc;

typedef union S_tyccncc
{
  typcc cc;
  typncc ncc;
} tyccncc;

typedef struct S_tynqsfield
{
  double vss,covgs,covgd,covgb,cjbs,cjbd;
  double gdd,gdg,gds,gsd,gsg,gss,gbd,gbs;
  typcc cc;
  typncc ncc;
} tynqsfield;


typedef struct S_tyDEVSUP
{
  double *param;
  long *pin_index;
  long nbpins;
} tyDEVSUP;


/**************** For sup_info field and SRM ***************/

#define SUPD_nsquare 0 /* AREA for SRM*/
#define SUPD_tc3     1
#define SUPD_ctc1    2
#define SUPD_ctc2    3
#define SUPD_w       4 /* W for SRM*/
#define SUPD_l       5 /* L for SRM*/
#define SUPD_nc      6 /* CL for SRM*/
#define SUPD_cl      6 /* cl of HSPICE same loc than nc*/
#define SUPD_nc2     7 /* CW for SRM*/ 
#define SUPD_cw      7 /* cw of HSPICE same loc than nc2*/
#define SUPD_acval   8 
#define SUPD_scale   9 
#define SUPD_mult   10 
#define SUPD_dtemp  11
#define SUPD_r      12 /* R for SRM*/
#define SUPD_dserie 13 
#define SUPD_af     14
#define SUPD_fc     15
#define SUPD_weexp  16
#define SUPD_leexp  17
#define SUPD_fexp   18
#define SUPD_cfmax  19 /* maximum frequency for convolution */
#define SUPD_cdelf  20 /* deltaf for convolution*/
#define SUPD_fit    21 /* keyword to use fitting */

#define SUPD_MAX    22 /* Must be max of above... */



typedef struct S_info_dip
{
  double SUPDVAL[SUPD_MAX + 1];
  void  *RAC_HEI;
  double oldcval; long icap,icap2; char *addcap;
  long imosrm; /* type of Elem: SRM, R */
  char SUPDG[SUPD_MAX + 1];
  void *RAC_TRAN; /* For evaluating AC expression in TRAN */
} tysup_info_dip;

/*** To hold device temperature... */
typedef struct S_tytemptrans
{
  double ttemp;
  char codettemp; /* 0 if not specified, 
                     1 if DTEMP specifed, 
                     2 if TEMP specified.. */
} tytemptrans;

/**************************************************
*
*   Simulation Status 
*
****************************************************/

#define EI_MSG_OK        0 /* Nothing */
#define EI_MSG_ERR       1 /* error */
#define EI_MSG_WARN      2 /* Warning */

/* Values for ei_protocol */
#define EI_P_NONE    0
#define EI_P_LONG    1
#define EI_P_GO      2 /* Eldo running, or quit */

/* Values for Eldo STatus */

#define ES_ANALYSIS          1
#define ES_GENERATION        2
#define ES_COMPERR           3
#define ES_COMPOK            4
#define ES_NOSUCHFILE        5
#define ES_ERR_OPEN          6
#define ES_RUNTIME_ERR       7

#define ES_DC                11
#define ES_TRAN              12
#define ES_AC                13
#define ES_DC_RAMP           14
#define ES_DC_SOLVE          15
#define ES_DC_SWEEP          16
#define ES_HB                17
#define ES_CT                18
#define ES_SDSIM             19

#define ES_DC_FAILED         21
#define ES_TRAN_FAILED       22
#define ES_AC_FAILED         23
#define ES_DC_RAMP_FAILED    24
#define ES_DC_SOLVED_FAILED  25
#define ES_DC_SWEEP_FAILED   26

#define ES_END_SIMU          27


/* For sim_mode_state */
#define ES_SIM_STEP_INIT            1 
#define ES_SIM_STEP_ITER            2
#define ES_SIM_STEP_DONE            3
#define ES_SIM_STEP_REJECT          4


/* for submode */

#define ES_SIM_NORMAL         1
#define ES_SIM_AC_NOISE       2
#define ES_SIM_AC_OP          3
#define ES_SIM_INIT_TRANSIENT 4

typedef struct S_D_SimVar
{
  double 
         exval,           /* XAXIS value: TIME, FREQ... */
         step,            /* XAXIS STEP */
         debval,          /* X first point */
         endval,          /*  not used */
         temp,            /* Temperature */
         pstep,           /* .STEP value */
         dc2,             /* for nested DC sweep */
         sim_mode,        /* Type of analysis: ES_AC ES_DC ES_TRAN ... */
         sim_mode_state,  /* ES_SIM_STEP_INIT,
                             ES_SIM_STEP_ITER,
                             ES_SIM_STEP_DONE : for TRANSIENT analysis */
         submode,         /* ES_SIM_NORMAL,
                             ES_SIM_AC_NOISE,
                             ES_SIM_AC_OP,
                             ES_SIM_INIT_TRANSIENT : First call in TRANSIENT: DC is
                                                     done in case there were no UIC 
                             */
         xaxis_code,      /* ficou X unit */
         sampling  ,      /* not used */
         ugmin ,
         reltol,
         last_step,
         idc1,            /* For DC sweep: index of the sweep */
         idc2,            /* For DC sweep: index of sweep number 2 */
         ilinlog,         /* TSDB_LIN, TSDB_LOG, TSDB_OCT */
         pexval;
} ty_D_SimVar; /* beware to modifiy 
                  tabudm.h and misnanc.c in case that order above is
                  changed */

typedef struct S_tyMG_Mid 
{
  /* contains device information on how to execute the model */
  int simid;         /* Simulator id */
  int flag_mode;     /* not used now: set at 0.0 */
  int returned_code;
  int esc_ptr;       /* 0.0*/
  int modtype;       /* 1 for N, -1 for P */
  int instid;        /* key for device being used */
  int cder;          /* 1 if derivative needs been computed, 0 otherwise: used for
                         models which can return derivatives. */
  int nominal;       /* Case of numerical derivative: 1 if nominal call, 0 otherwise. */
  int modlevel;      /* Level in the .MODEL card */
} tyMG_Mid; /* beware to modifiy 
               tabudm.h and misnanc.c in case that order above is
               changed */


/* For Gudm numerical derivatives.. */
typedef struct ty_gudm_mat {
  long lig;
  long col;
} ty_gudm_mat_S;

#define ELDO_FIDEL       1
#define ELDO_MOZART      3
#define ELDO_LSIM        4
#define ELDO_HILO        5
#define ELDO_QSIM        6
#define ELDO_VERILOG     7
#define ELDO_MINT        8
#define ELDO_QUICKSIM    9
#define ELDO_BKP        10
#define ELDO_EMUL       11
#define ELDO_DIGFAS     12
#define ELDO_HHDLA      13
#define ELDO_PRECEDENCE 14

#define M_ELDO          1
#define M_ELDO_PRECISE  2
#define M_ELDO_ACC2     3
#define M_ELDO_ST       4
#define M_ELDO_MHS      5
#define M_ELDO_MOTOROLA 6

/* Values for ianalyse */
#define ANALYSTRAN     1 	/* transient analysis = 1 */
#define ANALYSDC       2 	/* DC analysis = 2 */
#define ANALYSDCTRAN   3 	/* DC & transient analysis = 3 */
#define ANALYSAC       4 	/* AC analysis = 4 */
#define ANALYSACTRAN   5 	/* AC & transient analysis = 5 */
#define ANALYSDCSWNODE 6        /* DCSWEEP on NODE: not used anymore */
#define ANALYSDCSWEEP  7        /* DCSWEEP on object */
#define ANALYSNOISE    8        /* NOISE analysis */
#define ANALYSPORT     9        /* S,Y,Z PORT analysis */
#define ANALYSHB      10        /* HB analysis */
#define ANALYSFFT     11        /* FFT processor */
#define ANALYSPREFFT  12        /* TRAN wave for FFT */
#define ANALYSCT      13
#define ANALYSNTR     14        /* For NTR measurements */
#define ANALYSSDSIM   15        /* SDSIM.. */
#define ANALYSSHOOT   16        /* Shooting... */
#define ANALYSDSP     17        /* DSP post-processor */
#define ANALYSPREDSP  18        /* DSP post-processor */
#define ANALYSSWEEP   19        /* Sweep analysis */
#define ANALYSLSTB    20        /* LSTB analysis */

/*** For parsing ***/
#define _THAT_DEVICE 25000000
#define _THAT_MODEL  25000000
#define _THAT_MODIP  25000000
#define _NOEBULLE    -1000001
#define _TECHNO_SUPP    50000
#define _TECHNO_FAS   1000000
#define _TECHNO_NOUP   999999

#define NEEP_M 'M'
#define NEEP_S 'S'
#define NEEP_Q 'Q'
#define NEEP_J 'J'
#define NEEP_D 'D'
#define NEEP_R 'R'
#define NEEP_C 'C'
#define NEEP_L 'L'
#define NEEP_F 'F'
#define NEEP_I 'I'
#define NEEP_Z 'Z'

#define H_E      'E'
#define H_F      'F'
#define H_G      'G'
#define H_H      'H'
#define H_S      'S'
#define H_Z      'Z'
#define H_RPOLY  'R'
#define H_CPOLY  'C'
#define H_LPOLY  'L'
#define H_RVAL   'r'
#define H_CVAL   'c'
#define H_LVAL   'l'
#define H_K      'K'
#define H_Y      'Y'
#define E_EVAL   'e'
#define H_IVAL   'i'
#define H_T      'T'
#define H_VCR    'v'
#define H_VCCAP  'a'

#define BIP_CBCP 1
#define BIP_CBEP 2
#define BIP_CCSP 3

#ifdef MEPROC
#define MOSARGU long  itra,double  vvg, double  vv1, \
                 double  vv2,double  vvb, long miproc
#define USE_MOSARGU itra,vvg,vv1,vv2,vvb,miproc

#define DIOARGU register struct S_tytra * T, \
              register struct S_tygeo * TY, \
              register struct S_tymod * M, \
              double  VBE, long miproc
#define JFETARGU long  itra, double  vgs, double  vgd, long miproc

#else
#define USE_MOSARGU itra,vvg,vv1,vv2,vvb
#define MOSARGU long  itra,double  vvg, double  vv1, \
                 double  vv2,double  vvb
#define DIOARGU register struct S_tytra * T, \
              register struct S_tygeo * TY, \
              register struct S_tymod * M, \
              double  VBE
#define JFETARGU long  itra, double  vgs, double  vgd

#endif



typedef enum S_defscale_type{
  SCALE_ALL_PARAMS,
  SCALE_PARAMS,
  SCALE_ALL_ELEMENTS,
  SCALE_ALL_MODELS,         
  SCALE_ALL_ELEMENTS_EXCEPT,
  SCALE_ALL_MODELS_EXCEPT,
  SCALE_ALL_PARAMS_EXCEPT,
  SCALE_ELEMENTS,
  SCALE_MODELS, 
  DEFAULT_ALL_ELEMENTS,
  DEFAULT_ALL_MODELS 
}defscale_type;


typedef enum S_scale_scope{
  GLOBAL_SCOPE,
  HIER_SCOPE
}scale_scope;

typedef enum S_scale_kind{
  NAMED,
  PARTIAL,
  ALL
}scale_kind;

/*default names kind must be partial. It is impossible in the current scale syntaxe to know if we are dealing with a complete name or a partial name.   NAMED is currently insupported*/

typedef struct S_tydefscaleitem{
  scale_scope           item_scope;
  scale_kind            item_kind;
  char*                 item_name;
  long                  item_index;
  struct                S_tydefscaleitem *next;
  char                  item_used;/*if item never called warn the user that it has not been processed*/
}tydefscaleitem;


typedef struct S_tydefscale{
  defscale_type type;
  char naturemod;
  char typemod;
  long rlevel;
  long elevel;
  long sommet;/*.scale or .default*/
  double *ivalues;
  char has_off;
  char has_ic;
  struct S_tydefscaleitem  *itemslist;/*models or devices names*/
  struct S_tydefscale*next;
}tydefscale;



#endif /* typmod_included */


     





