static char cvsid[]="@(#) Anacad $Id: usermod_example.c,v 1.11 2002/12/10 11:10:20 joelb Exp $"; /* %Z%%M% %I% %E% Anacad */
/*------------------------------------------------------------*/
/*                 ANACAD COMPUTER SYSTEM                     */
/*            COPYRIGHT                1990                   */
/*------------------------------------------------------------*/
/*                                                            */
/*     name : usermod.c     |      release :                  */
/* language :  C            |      version : v.0.1            */
/*     date : 06.19.2006    |      author  : OFS              */
/*                                                            */
/*------------------------------------------------------------*/
/*                                                            */
/* parameters                                                 */
/* ==========                                                 */
/*                                                            */
/*  name   type  IN/OUT              function                 */
/*                                                            */
/*                                                            */
/*------------------------------------------------------------*/
/*                                                            */
/* modifications                                              */
/* =============                                              */
/* Osmar FSiebel              Modification  02/19/2008        */
/*                                                            */
/* This file has problem with slope factor. Acm plus 
capacitance is good                                           */
/*------------------------------------------------------------*/

#include "machine.glob"
#include "typmod.h"
#include "varmod1.h"
#include "varmod2.h"



typedef struct S_tyuser1{
  /* can be used to store geometrical dependant quantities. See the
     note for alloc_user_field() */
  double dummy1;
  double dummy2;
  /* and so on if needed */
} tyuser1;
/* for level 22 */
typedef struct S_tyuser2{
  double isat;
  double dummy2;
  /* and so on  if needed */
} tyuser2 ;
/* and so on if needed */

tyuser1 ** tranuser1;
tyuser2 ** tranuser2;
/* and so on if needed */

/* Including prototype files*/
#include "bruitmod_acc.h"
#include "usermod_acc.h"
#include "techno_acc.h"
#include "modhead_acc.h"
/* End of prototype files */

/******************************************************************************/
/***********************  usermod_model_version_name()  ***********************/
/******************************************************************************/

char* usermod_model_version_name(
#if defined(__STDC__) || defined(__cplusplus)
                 long  imod
                )
#else
                 imod
                )
     long imod;
#endif
{


  register struct S_tymod *M = &(modmos[imod]) ;

  return("My version of code ACM ");
}


double udm_success_param_mos  (
#if defined(__STDC__) || defined(__cplusplus)
                              long  level
                             )
#else
                              level
                             )

long level;
#endif
{
  double ntotal;

  /* ntotal is the number of parameters of the user defined
     MOS model. If this new model should be used with the
     the SUCCESS Device Parameter Extraction System, please
     give "ntotal" the correct number of parameters  
     ( the maximum of the parameter number is 200)  */
         switch(level)
                        {
                        case 20 : ntotal = 000; break;
                        case 21 : ntotal = 000; break;
                        case 22 : ntotal = 000; break;
                /*      case 23 : ntotal = 000; break;  and so on  */

                        default: break;
                        }
  return(ntotal);
}


/*****************************************
*
*  function tabudm_mos_config
*
***********************************/

void tabudm_mos_config  (
#if defined(__STDC__) || defined(__cplusplus)
                        long  imod,
                        long * tabudm
                       )
#else
                        imod,
                        tabudm
                       )
long imod; long *tabudm;
#endif
{
  /* Set  *tabudm = 1  to force Eldo to use tabudm interface;
          default is 0 */
   *tabudm = 0; 
}


/*****************************************
*
*  function Gudm_mos_config
*
***********************************/

long Gudm_mos_config  (
#if defined(__STDC__) || defined(__cplusplus)
                        long  imo,
                        long * nbs,
                        long * nbnoe,
                        long * nbq
                       )
#else
                        imo,
                        nbs,
                        nbnoe,
                        nbq
                       )
long imo;
long *nbs,*nbnoe,*nbq;
#endif
{
  *nbs = *nbnoe = *nbq = 0;
  return(0); /* To disable Gudm */
}

/*--------------------------------------------------------------------
 alloc_user_field() "Allocation of tyuser structures "

 purpose:           Allocation of tyuser structures.
 syntax:            alloc_user_field(how_many)
 example call:      CALLED INTERNALY BY THE SIMULATOR.
 arguments:         how_many. number of MOS transistors in the circuit.
 description:       This routine allocates one or more tyuser structure.
                    It is fully commented for the allocation of two such 
                    structures, and then (we hope) no problem shall appear 
                    for the user.  
                    interface called by the simulator.
 comments:          see note below and also inigeouser().

 IMPORTANT NOTE.

  A MOS model is composed of a set of equations to compute currents and
dynamic contributions (charges/capacitances). These equations are using
general physical quantities which are extracted from measurements and are 
valid for a lot of different transistors and which constitute a MODEL card.
  For instance the Bulk to source diode current is often computed in the
following way:

            IBS = Isat(exp(qV/kT) - 1)

	where 	V is the voltage across the diode,
		q is the electronic charge,
		k is the Boltzman constant,
		T is the temperature of the device,
		Isat is the saturation current.

        and  Isat = IS * AS  

	where	IS is the bulk junction saturation current
		AS is the source area.

  Since q and k are unique, they are not a part of a MODEL card. All
simulators know internally their value.
  T often comes from such simulator commands as .TEMP. But it can also
come in ELDO from the MODEL parameter TMOD. In that case ALL the MOS
transistors refering to this model will have the same temperature T.
 IS is a MODEL parameter. It is representative of the physical behavior 
of a class of transistors which are produced in the same technology.
IS is extracted from physical measurements.
 AS is the source area of a particular transistor. 

  For each transistor in the netlist and also for each voltage V, the IBS
current is computed, as well as the drain current IDS, the bulk to drain
current IBD , and the charges and/or capacitances. This leads to a huge
amount of computation and then to a long CPU time. If we consider now that
Isat does not depend on voltages but only on the transistor size, we notice
that it is absolutly no use to compute Isat for each voltage and that the 
time needed to multiply IS by AS is lost CPU time. For one parameter, or
for a simple multiplication it makes no difference, but in most cases, we
can find at least 10 parameters like Isat in model equations (50 for the
second BSIM model), and the equations are not so simple.

  Therefore, we recommend the use of the tyuser and tygeo structures. With
the help of these structures and the relevant routines inigeouser() and
alloc_user_field(), we allow the computation of such geometrical dependent
quantities and their storage for later use. Care must however be taken
since another problem can appear : memory problem. For instance let's assume
that we have a circuit of 10,000 transistors, and that we want to pre-compute
20 geometrical dependent quantities. We will then have to allocate 10,000
tyuser stuctures containing each 20 doubles (8 bytes), i.e 1.6 Mbytes. The
computation being saved can then be lost in swapping. It is up to the user
to decide of the best compromise between memory allocation and CPU time.

  The difference between the tygeo structure and a tyuser structure is that
the tygeo is ALWAYS allocated for each transistor. That means that it has to
be used in priority to store such variables. The inconveniences of this tygeo
structure is that the variable names  ave no special meanings for the user,
and that only 10 doubles are available. With the tyuser structure, there is 
no limitation for the number of doubles and for the variable names since the
user allocates it himself. For the tyuser structures only one or more pointer 
of pointer is allocated for all the MOS, and the structure itself is allocated
only for the transistor refering to the user's model.
--------------------------------------------------------------------*/
void alloc_user_field  (
#if defined(__STDC__) || defined(__cplusplus)
                       long  how_many
                      )
#else
                       how_many
                      )
long how_many;
#endif
{
  
 /* long i;
  tranuser1 = (tyuser1 **) memalloc(sizeof(tyuser1*) * (how_many + 1));
  tranuser2 = (tyuser2 **) memalloc(sizeof(tyuser2*) * (how_many + 1));
  and so on if needed ... 
  for(i=0; i<= how_many; i++) 
  {
    tranuser1[i] = NULL;
    tranuser2[i] = NULL;  and so on if needed ... 
  } */
/*  for(i=0; i<= how_many ; i++)
  {
    if(trans[i].neep == 'M')    MOS transistor.
    {
      if(modmos[trans[i].imo].niv == 21)
        tranuser1[i] = (tyuser1 *) meldalloc(sizeof(tyuser1));
      if(modmos[trans[i].imo].niv == 22)
        tranuser2[i] = (tyuser2 *) meldalloc(sizeof(tyuser2));
      and so on if needed ...
    }
  }  
  */
}


/*****************************************
*
*  function free_udm_alloc_field
*
***********************************/

void free_udm_alloc_field  ()
{
  /* Free here memory allocated via memalloc(): memory allocated via
     meldalloc() is automatically freed */
}


void  user_field_info(
#if defined(__STDC__) || defined(__cplusplus)
		      long imo,void **add,long *size,
                               void **add2,long *size2,
                               void **add3,long *size3)
#else
                      imo,add,size,add2,size2,
                      add3,size3)
long imo; void **add; long *size;
void **add2; long *size2;
void **add3; long *size3;
#endif
{

  long level;

  level = modmos[imo].niv;

  /* Depending on level, return the address and the size of
     field allocated... In our exemple, we would have code like:
     if(level == 21) 
     {
       *add = (void**) tranuser1; 
       *size = (long) sizeof(tyuser1);
     }
     if(level == 22) 
     {
       *add = (void**) tranuser2; 
       *size = (long) sizeof(tyuser2);
     }
     add2 and size2 used only if for the same level, a second
     field is allocated...
     ***/

  *add = NULL;
  *size = 0;   
  *add2 = NULL; *size2 = 0;
  *add3 = NULL; *size3 = 0;
}

void udm_get_wleffcv (
#if defined(__STDC__) || defined(__cplusplus)
                       long  itra,
                       double * weffcv,
                       double * leffcv
                      )
#else
                       itra,
                       weffcv,
                       leffcv
                      )
long itra;
double *weffcv,*leffcv;
#endif
{
register struct S_tygeo  *TY = &(trageo[itra]) ;

/*
 * Note: Values returned are in um
 */

  *weffcv = 0.0;             
  *leffcv = 0.0;
}

/*****************************************
*
*  function get_device_locprint_user
*
***********************************/

long get_device_locprint_user  (
#if defined(__STDC__) || defined(__cplusplus)
                               long  itra
                              )
#else
                               itra
                              )
long itra;
#endif
{ 
  /* Return here how many internal variables
     the model is capable to return for
     print/plot purposes: Eldo will allocate memory
     for such a number of variables */
  return(0);
}


/*****************************************
*
*  function print_index_user
*
***********************************/

long print_index_user  (
#if defined(__STDC__) || defined(__cplusplus)
                       long  itra,
                       char * name
                      )
#else
                       itra,
                       name
                      )
long itra; 
char *name;
#endif
{
  long res = -1;
  /* name is the name of the parameter to display:
     return an index for that name, that will be used
     in routine below.
     Example: if (strcmp(name,"MY_VT" == 0) return(1); <- MY_VT has index 1.
              if (strcmp(name,"MY_VDSS" == 0) return(2); <- MY_VDSS has index 2.
     Note that with that example, routine above should have returned number 3.
     And then, each time the model is called, call routine:

     save_device_var(itra,pos,value);
     itra is the key to the device being evaluated;
     pos is the key to the parameter (1 for MY_VTH in that example)
     value is a double and contains the value which will be displayed.
  */
     
  return(res);
}


/*****************************************
*
*  function state_unit_user
*
***********************************/

long state_unit_user  (
#if defined(__STDC__) || defined(__cplusplus)
                      long  itra,
                      long  state
                     )
#else
                      itra,
                      state
                     )
long itra; long state;
#endif
{
  long res=0;
  /* This routine is used to assign units to internal variables, to
     get correct unit in graphic-postprocessor.
     'state' is the index returned by routine above: the unit must
     be chosen in ficou.h */
  return (res);
}

/*****************************************
*
*  function user_get_min_extended
*
***********************************/

long user_get_min_extended(
#if defined(__STDC__) || defined(__cplusplus)
			   long level)
#else
                           level)
long level;
#endif
{
/* this function must return the number of extended parameters for
   the .MODEL card. These parameters will be put inside M->sup_param array.
   - Note1: The extended parameters must be used only when the base structur
     typmod is full to avoid any waste of memory.
   - note2: the function associate_param_devlev_extended(name,index,level)
     can be used to assosiate parameters to extended parameters like
     associate_parameter_devlev() is used for non extended. */

  return (0);
}

/*--------------------------------------------------------------------
 load_udm_parameter() "loading of parameter synonymous "

 purpose:           load the User Defined Parameter Names.
 syntax:            load_udm_parameter()
 example call:      CALLED INTERNALY BY THE SIMULATOR.
 description:       This routine allows the user to define its own model
                    parameter names to be used in the model card. The aim
                    of this routine is to associate to a user parameter
                    name a field of the tymod structure. For more details
                    on the tymod structure refer to file typmod.h.
 comments:          ELDO, for historical reasons knows already a lot of
                    parameter names (coming from Berkley or Merckel or other
                    models), which are already associated to tymod fields.
                    In the case where the user tries to associate a para-
                    meter name which is already known by ELDO to another
                    field of the tymod structure, ELDO will issue an error
                    message at the first run.
----------------------------------------------------------------------*/
void load_udm_parameter  ()
{
  /* You may call here the function:

     associate_param_devlev(name,synonymous,LEVEL)
     char *name; char *synonymous;

     For instance, if a parameter VTOO should be recognized by ELDO in the
     .MODEL card and assume you want to store its value in the field p80 of
     the tymod structure and then afterwards to refer to its value through
     M->p80 in the following model routines, then call:
     associate_param("VTOO","p80",21); and so on*/


      associate_param_devlev("MU0","MU0",21);/*Carrier Mobility*/
      associate_param_devlev("MUO","MU0",21);/*Carrier Mobility*/
      associate_param_devlev("UO","MU0",21);/*Carrier Mobility*/
      associate_param_devlev("U0","MU0",21);/*Carrier Mobility*/
      associate_param_devlev("TOX","EOX",21);/*Oxide thickness*/
      associate_param_devlev("EOX","EOX",21);/*Oxide thickness*/
      associate_param_devlev("SIGMA","p4",21);/*Drain-induced barrier lowering factor*/
      associate_param_devlev("UCRIT","UCRIT",21);/*Longitudinal Critical Electrical Field for mobility degradation*/
      associate_param_devlev("XJ","p7",21);/*Junction depth*/
      associate_param_devlev("LAMBDA","LAMBDA",21);/*Channel length modulation factor*/
      associate_param_devlev("VFB","p13",21);/*Flat-band Voltage*/
      associate_param_devlev("XQC","XQC",21);/*Eldo parameter - Charge or Capacitance*/
      associate_param_devlev("NA","NSUB",21);/*Substrate Concentration*/
      associate_param_devlev("NSUB","NSUB",21);/*Substrate Concentration*/
      associate_param_devlev("NCH","NSUB",21);/*Substrate Concentration*/
      associate_param_devlev("M","p15",21);/*Temperature Factor of Mobility*/
      associate_param_devlev("ALPHATHETA","p17",21);/*Mobility Reduction Factor*/


}
/*--------------------------------------------------------------------
 flicker_noise_mos() "Computing the flicker noise "

 purpose:           computes the flicker noise contribution of MOS device.
 syntax:            flicker_noise_mos(itra,ids,gm,fourkt,freq,vtemp)
 arguments:         (long) itra : MOS index
                    ids : Current through the device
                    gm : d(ids)/VG
                    fourkt : 4* KB * T
                    freq : frequency
                    Area: scale factor of the device

 example call:      CALLED BY THE SIMULATOR IN CASE OF NOISE ANALYSIS.
 description:
 comments:          May be used for later versions than 4.1
----------------------------------------------------------------------*/
double flicker_noise_mos  (
#if defined(__STDC__) || defined(__cplusplus)
                          long  itra,
                          double  ids,
                          double  gm,
                          double  fourkt,
                          double  freq,
                          double  Area
                         )
#else
                          itra,
                          ids,
                          gm,
                          fourkt,
                          freq,
                          Area
                         )
long itra;
double ids,gm,fourkt,freq,Area;
#endif
{
  tytra *T;
  long fl_lev;
 double vno4, length;

  fl_lev = extract_fl_lev(itra, flicker_noise);
  T = trans + itra;
  length = T->ld * 1.0e-6; /* back in Meter */
  if (fl_lev == 0) /*default value: SPICE2G6 Model */
  {
    vno4 = modmos[T->imo].kf * exp(modmos[T->imo].af *
           log(ids)) / (freq * modmos[T->imo].cox *length*length);
  }

  return(vno4);
}
/*--------------------------------------------------------------------
 thermal_noise_mos() "Computing the thermal noise "

 purpose:           computes the thermal noise contribution of MOS device.
 syntax:            thermal_noise_mos(itra,ids,gm,fourkt,vtemp)
 arguments:         (long) itra : MOS index
                    ids : Current through the device
                    gm : d(ids)/VGS
                    gd: d(ids)/vds
                    gmb: d(ids)/vbs
                    vdss: saturation
                    fourkt : 4* KB * T
                    Area: multiplication factor of the Device

 example call:      CALLED BY THE SIMULATOR IN CASE OF NOISE ANALYSIS
 description:
 comments:          May be used for later versions than 4.1
----------------------------------------------------------------------*/

double thermal_noise_mos  (
#if defined(__STDC__) || defined(__cplusplus)
                          long  itra,
                          double  ids,
                          double  gm,
                          double  gd,
                          double  gmb,
                          double  vds,
                          double  vvdss,
                          double  fourkt,
                          double  Area
                         )
#else
                          itra,
                          ids,
                          gm,
                          gd,
                          gmb,
                          vds,
                          vvdss,
                          fourkt,
                          Area
                         )
long itra;
double ids,gm,gd,gmb,vds,vvdss,fourkt,Area;
#endif
 {
  long th_lev;
  double vno3;

  th_lev = extract_th_lev(itra, thermal_noise);
  if (th_lev == 0) /*default value : SPICE2G6 Equation */
  {
    vno3 = fourkt * fabs(gm) / 1.5e0;
  } else
  {
    /* any formula*/
    vno3 = 0.0;
  }
  return(vno3);
 }

/*--------------------------------------------------------------------
 trace_user() "Printing of the model parameters "

 purpose:       allows the user to print the model parameters in the .chi file.
 syntax:        trace_user()
 example call: 	CALLED INTERNALY BY THE SIMULATOR.
 arguments:     (long) imod is the model index.
 description:   The user can access to the relevant model structure via
                the index imod, and then print the desired parameters value
                in the .chi file. Its file pointer vchi is a global variable.
 comments:      For more explanation of the modmos structure see typmod.h.

--------------------------------------------------------------------*/
void trace_user  (
#if defined(__STDC__) || defined(__cplusplus)
                 long  imod
                )
#else
                 imod
                )
long imod;
#endif
{
  { register struct S_tymod *M = &(modmos[imod]) ;

    

  }
}
/*--------------------------------------------------------------------
 initempuser() "Temperature Updating of MODEL parameters "

 purpose:       allows the user to update the model parameters in temperature.
 syntax:        initempuser(imod)
 example call:  initempuser(imod);
 arguments:     (long) imod is the model index.
 description:  	The Model strucure to be processed is modmos[imod].                             The Model temperature (TMOD in the MODEL card) can be accessed
                via M->temp (or modmos[imod].temp) in degrees C.
                The Nominal temperature (TNOM in the MODEL card or .OPTION TNOM
                or the default value 27 degrees C) can be accessed via M->tnom
                (or modmos[imod].tnom) in degrees C.
                The reference temperature is reftmp : 300.15 K and tnomref is
                273.15 K.
                The current temperature is temperature[itemp] and the previous
                temperature is temperature[itemp - 1], both in K.
--------------------------------------------------------------------*/
void initempuser  (
#if defined(__STDC__) || defined(__cplusplus)
                  long  imod
                 )
#else
                  imod
                 )
long  imod;
#endif
{
tymod *M;
   double new_reftmp,temp6,temp7,temp8;

   M = modmos + imod; /* pointer to the relevant model structure */

    get_model_reftmp(imod,&new_reftmp);
    get_model_temp(imod,&temp6,&temp7);

/* temp2: current temperature :   M->mktsurq, M->megfet
   temp1: previous temp       :   M->moldvt,  M->moldeg     */

  /* here is an example of the dependency of mu0 with temperature*/

     temp8=temp7 / temp6;
     M->mu0 = M->mu0 * pow(temp8,-M->p15);/*Mobility in function of temperature*/

	     

}


/*--------------------------------------------------------------------
 initmospar_user() "MODEL parameters default values "

 purpose:       allows the user to set default values for its model parameters.
 syntax:        initmospar_user(imod)
 example call:  CALLED INTERNALY BY THE SIMULATOR.
 arguments:     (long) imod is the model index.
 description:   This routine is called only once at the beginning of the 
                simulation to allow the setting of the default values of
                parameters which are not specified in the input desk.
                A parameter is not given in the input deck if its value
                is less than UNDEF, where UNDEF is a reserved value.
                This routine can also be used to compute other useful 
                parameters which do not depend on geometries or voltages.	
                In this case these computed parameters can use dummy fields
                of the modmos structure.
                This routine can also be used for units conversions.
 comments:      Since ELDO uses the field M->vt0 for some initializations and
                the field M->cox in case of NOISE analysis, care should be
                taken to do the following things:
                - save in M->vt0 the absolute value of VTO.
                - load in M->cox the cox value in pF/
                M->cox must contain epsox/TOX since this value is used to
                compute the noise contribution of the device.
                Also note that parameters name LMIN,LMAX,WMIN and WMAX
                are used in the OPTIMIZE mode, and are supposed to
                contain the min and max size allow by the technology
                for the current model: they have to be specified in
                MKSA if the OPTIMIZER has to be used.
--------------------------------------------------------------------*/
void initmospar_user  (
#if defined(__STDC__) || defined(__cplusplus)
                      long  imod,char do_rescale
                     )
#else
                      imod,do_rescale
                     )
long imod; char do_rescale;
#endif
{
   
   tymod *M;
   M = modmos + imod; /* pointer to the relevant model structure */
   double aux;

   /*epsox F/m and eox meters*/


   /*Definition of default parameters*/

  /* DEFAULT VALUES */
  IF (M->noup == 'N')
  {
  IF(M->mu0 < UNDEF) M->mu0 = 0.05; /*Mobility*/
  }
  IF (M->noup == 'P')
  {
  IF(M->mu0 < UNDEF) M->mu0 = 0.015;/*Mobility*/
  }
  /*Oxide Thickness*/
  IF(M->eox < UNDEF) M->eox = 7e-9;
  M->cox = epsox / M->eox;
  /*Drain Induced Barrier Lowering*/
  IF(M->p4 < UNDEF) M->p4 = 3.0e-15;/*sigma DIBL*/
  IF(M->ucrit < UNDEF) M->ucrit = 2.6e6;
  
    
  /*Channel Length Modulation*/
  IF(M->p7 < UNDEF) M->p7 = 0.25e-6;/*xj junction depth*/
  IF(M->lambda < UNDEF) M->lambda = 0.25;/*channel length modulation factor*/
  
  /*Mobility*/
  IF(M->p17 < UNDEF) M->p17 = 1e8;/*mobility coeficient - ALPHATHETA*/
  
  /*Flat-band Voltage*/
  IF(M->p13 < UNDEF) M->p13 = -1.0;
  
  IF(M->xqc < UNDEF) M->xqc = 0.0e0;
  IF(M->nsub < UNDEF) M->nsub = 2.0e17;/*NA dopagem*/
  IF(M->p15 < UNDEF) M->p15 = 1.2; /*m Temperature Factor of Mobility*/
  
  /*Body effect*/
  IF(M->p3 < UNDEF)
  {
    M->p3=sqrt(2*charge*M->nsub*1.0e6*epsox * 11.8/3.9)/M->cox;/*p3 is gamma*/
   }
   /*Fermi Potential*/
  M->p5 = M->mktsurq * log(M->nsub/1.45e10);

   /*Lc parameter*/
   M->p10 = sqrt(epsox * 11.8/3.9 * M->p7 / M->cox);/*p10 is lc   p7 is xj   */






}
/*--------------------------------------------------------------------
 initmosuser() "Model parameters initializations"

 purpose:       call to initempuser().
 syntax:        initmosuser(imod)
 example call: 	CALLED INTERNALY BY THE SIMULATOR.
 arguments:     (long) imod is the model index..
 description:   This routine is called at the beginning of the simulation
                and for each new temperature. It calls also initempuser()
                to update the modmos structure with temperature. Then other
                useful parameters which do not depend on geometries or
                voltages can be computed and stored in unused fields of
                the modmos structure.
 returns:       nothing.
 comments:      Useful parameters can then be computed either in this routine
                or in initmospar(). The difference is that the latter is
                called only once, and that the first is called for each new
                temperature.
                Therefore initmosuser() should be used to compute parameters
                which depend on model parameter which need to be updated in
                temperature.
--------------------------------------------------------------------*/
void initmosuser  (
#if defined(__STDC__) || defined(__cplusplus)
                  long  imod
                 )
#else
                  imod
                 )
long  imod;
#endif
{
tymod *M; double xnoup;
  M  = modmos + imod;
  initempuser( imod) ; /*Chama a rotina initempuser para atualizar mobilidade com a temperatura*/

}


/*****************************************
*
*  function mos_nqs_user
*
***********************************/

void mos_nqs_user  (
#if defined(__STDC__) || defined(__cplusplus)
                   long  i,
                   double  pulsation,
                   double  v1,
                   double  v2,
                   double  vg,
                   double  vb,
                   tynqsfield  nqs_fld,
                   double * reel,
                   double * ima
                  )
#else
                   i,
                   pulsation,
                   v1,
                   v2,
                   vg,
                   vb,
                   nqs_fld,
                   reel,
                   ima
                  )
long i;
double pulsation,v1,v2,vg,vb;
tynqsfield nqs_fld;
double *reel;
double *ima;
#endif
{
}

/*--------------------------------------------------------------------
 to_elec_user() "Updating of geometries. "

 purpose:	This routine can be used in case of geometries should be 
                updated.
 syntax:	to_elec_user(itra)
 example call: 	to_elec_user(itra);
 arguments:	(long) itra is the transistor index.
 description:	Most of the time, the original geometries given in the 
                input netlist which are drawn geometries need to be 
                superseded by electrical geometries for the computation 
                of the model. 
                For instance the SPICE levels use two MODEL parameters 
                LD and WD (channel length and channel width reduction) 
                to compute the electrical L and W with the following rules : 
                Lelectrical = Ldrawn - 2 * LD and
                Welectrical = Wdrawn - 2 * WD.
                This routine can then be used to update the drawn values. 
                Another method consists of using electrical local variables,
                and to keep in the wd and ld of the trans structure the drawn
                values. In that case to_elec_user() and to_drawn_user() should
                not be used.
--------------------------------------------------------------------*/
void to_elec_user  (
#if defined(__STDC__) || defined(__cplusplus)
                   long  itra
                  )
#else
                   itra
                  )
long itra;
#endif
{
  tytra *T; tymod *M;
  T = trans + itra; M = modmos + T->imo;

  

}
/*--------------------------------------------------------------------
 to_drawn_user() "Retrieving of geometries. "

 purpose:       This routine can be used in case of geometries should be 
                retrieved.
 syntax:        to_drawn_user(itra)
 example call:  to_drawn_user(itra);
 arguments:     (long) itra is the transistor index.
 description:   This routine allows the user to retrieve the original drawn 
                geometries in case where to_elec_user() has beenused.
                This routine is also used by the optimizer module.
--------------------------------------------------------------------*/
void to_drawn_user  (
#if defined(__STDC__) || defined(__cplusplus)
                    long  itra
                   )
#else
                    itra
                   )
long itra;
#endif
{

}

/*--------------------------------------------------------------------
 Mos_Area_user() "Computing of the area of a MOS"

 purpose:       This routine is called by the optimizer to compute the 
                AREA of the device, in case the AREA must be optimize.
 returns:       The value of this AREA. For instance, it can be only 
                L * W as below.
 example call:  area = Mos_Area_user(itra);
 arguments:     (long) itra is the transistor index.
--------------------------------------------------------------------*/
double Mos_Area_user  (
#if defined(__STDC__) || defined(__cplusplus)
                      long  itra
                     )
#else
                      itra
                     )
long itra;
#endif
{
  return(trans[itra].ld * trans[itra].wd);
}


/**********************************
*
* Used for printing purposes *
*
*************************************/

void udm_get_geoeff  (
#if defined(__STDC__) || defined(__cplusplus)
                     long  itra,
                     double * wd,
                     double * ld,
                     double * ad,
                     double * as,
                     double * pd,
                     double * ps
                    )
#else
                     itra,
                     wd,
                     ld,
                     ad,
                     as,
                     pd,
                     ps
                    )
long itra;
double *wd,*ld,*ad,*as,*pd,*ps;
#endif
{

}

/*--------------------------------------------------------------------
 curr_diode_udm() "MOS diode currents computation"

 purpose:       MOS diode currents computation.
 syntax:        curr_diode_udm(itra,vvg,vv1,vv2,vvb)
 example call: 	curr_diode_udm(itra,vvg,vv1,vv2,vvb);.
 arguments:     (long) itra is the transistor index.
                (double)vvg is the gate voltage referenced to 0.
                (double)vv1 is the voltage of node n1 referenced to 0.
                (double)vv2 is the voltage of node n2 referenced to 0.
                (double)vvb is the bulk voltage referenced to 0.
                All this voltages are computed with the sheet resistances  
                contribution.
 description:   This routine computes the two static diode currents courbd
                and courbs IN MA (MilliAmperes).
 comments:      see also the note for mosuserx(). 
                This routine may be called by the simulator when it has
                been asked to plot or print these diode currents.
                It can be called also by mosuserx() to compute the diode
                currents. The advantage of doing it is to have the source
                code of this computation at only one place. The disadvantage
                is to have one routine call more (than in the case where 
                these currents are directly computed in mosuserx()) which
                can degrade CPU time performance.
 returns:       Nothing since courbd and courbs are global variables.
----------------------------------------------------------------------*/

void curr_diode_udm  (MOSARGU)
{
 /* { register struct S_tytra *T = &(trans[itra]) ;
    register struct S_tygeo *TY = &(trageo[itra]) ; 
    register struct S_tymod *M = &(modmos[T->imo]) ;
   courbd = ; courbs = ;
  } */
}

/*--------------------------------------------------------------------
 compute_r_access_usermod() "Computing the access resistances"

 purpose:       Computation and loading in the fields xrd and xrs of
                the values of the intrinsic access resistances RS and RD of
                MOS of index itra. 
 arguments:     itra is the MOS device index.
                xrd is the drain access resistance in KOhms.
                xrs is the source access resistance in KOhms.
 returns:       0 in case where no intrinsic access resistances are present,
                1 otherwise.
                In case field rs_created (rd_created) is 1, then the 
                returned value for the rs (rd) must be 0.0.

 comments:      This routine is called during the generation of the 
                data base of ELDO in order to decide whether the access 
                resistances will be created as new objects or taken into
                account in the MOS computation with a kind of iteration
                algorithm.
                You may also call this routine from inside routine mosuser()
                below. The advantage of doing it
                is to have the source code of this computation at only one 
                place. The disadvantage	of this approach is that another
                call to a functio is done, which can degrade CPU time 
                performance.

 note:          The tymod fields rs, rd and rsh are already converted in 
                KOhms (they are converted during the model card loading phase).
                the returned values xrd and xrs must be i KiloOHMS.
--------------------------------------------------------------------*/

long compute_r_access_usermod  (
#if defined(__STDC__) || defined(__cplusplus)
                               long  itra,
                               double * xrd,
                               double * xrs
                              )
#else
                               itra,
                               xrd,
                               xrs
                              )
long itra; double *xrd,*xrs;
#endif
{
  tytra *T; tymod *M;  long resf = 0; double Area;
  T = trans + itra; M = modmos + T->imo;

  if((T->rs_created) && (T->rd_created)) 
  {
    /* rs and rd have been created: then, consider that
    the model has no intrinsic resistors */
    
    return(0);
  }

  IF (( M->rd != dzero)  || ( M->rs != dzero)  ) 
  {
    *xrd = M->rd; *xrs = M->rs;  
  }
  IF (M->rsh > dzero ) 
  {
    IF (T->nrd > dzero ) 
    {
       *xrd = M->rsh * T->nrd; 
    }
    IF (T->nrs > dzero ) 
    {
       *xrs = M->rsh * T->nrs; 
    }
  }
  if(*xrd > 0.0)
  {
    if(T->rd_created) 
    {
      /* no intrinsic resistor, because it has already been
         created as external device */
       *xrd = 0.0; 
    } else 
    {
      /* xrd contains the value of the intrinsix rd
         value; set the boolean to 1 to tell that 
         there is at least one intrinsic resistor */
      resf = 1;
    }
  }
  if(*xrs > 0.0)
  {
    if(T->rs_created) *xrs = 0.0; else resf = 1;
  }
  if(resf)
  {
    Area = 1.0;
    IF(Mos_Sup != NULL) 
    { 
      Area = (double) Mos_Sup[itra].Area;
    }
    IF(Mfact != NULL) Area *= Mfact[itra];
    if(Area != 1.0)
    {
      *xrd /= Area;
      *xrs /= Area;
    }
  }
  return(resf);
}

/*--------------------------------------------------------------------
 initdefgeo_mos_user() "Default values for MOS geometries"

 purpose:  	Sets default values for MOS geometries when not specified.
 syntax:	initdefgeo_mos_user(itra)    
 example call:  CALLED INTERNALY BY THE SIMULATOR.
 arguments:     (long) itra is the MOS device index.
 description:   This routine should be used to assign default values for 
                the MOS device geometries. These geometries are accessed 
                via the trans structure (for more detail see typmod.h). 
                itra is the relevant transistor index.
 comments:      This routine should also be used to deal with the case where 
                the width or the length is zero. 
--------------------------------------------------------------------*/
void initdefgeo_mos_user  (
#if defined(__STDC__) || defined(__cplusplus)
                          long  itra
                         )
#else
                          itra
                         )
long itra;
#endif
{
  tytra *T;
  T = trans + itra; 

}
/*--------------------------------------------------------------------
 inigeouser() "Computing and loading geometrical dependent values"

 purpose:   	allows the user to compute and store some geometrical
                dependent values, which will be used afterwards.
 syntax:	inigeouser(itra)
 example call:  CALLED INTERNALY BY THE SIMULATOR.
 arguments:     (long) itra is the trans sructure index.
 description:   This routine is called for each transistor device at the 
                beginning of the simulation and for each temperature.
                It should be used to compute values which depend on the 
                MOS geometries but not on voltages, and to store them. 
                This avoids making these computations in mosuserx and
                then always making the same computations for each new
                voltage. In other terms the use of this routine saves CPU 
                time.
 comments:      see also the note on alloc_user_field(). 
--------------------------------------------------------------------*/
void inigeouser  (
#if defined(__STDC__) || defined(__cplusplus)
                 long  itra
                )
#else
                 itra
                )
long  itra; 
#endif
{
  tytra *T;
  tygeo *TY;
  tymod *M; double CAPOX;
  /*
  tyuser1 *USER1;  if needed and already allocated
  tyuser2 *USER2;  if needed and already allocated
  and so on ...
  */
  T = trans + itra;
  TY = trageo + itra;
  M = modmos + T->imo;

  T->ld = T->ld*1.0e-6;
  T->wd = T->wd*1.0e-6;

  /*
  USER1 = tranuser1 + itra; if needed and already allocated
  USER2 = tranuser2 + itra; if needed and already allocated
  and so on ...
  */
  
}


/*****************************************
*
*  function new_step_mos_udm
*
***********************************/

void new_step_mos_udm  (
#if defined(__STDC__) || defined(__cplusplus)
                       long  itra,
                       long  code
                      )
#else
                       itra,
                       code
                      )
long itra;
long code; /* code is ES_SIM_STEP_DONE or ES_SIM_STEP_REJECT */
#endif
{
  /* A new TRAN step will be started: either previous step has been
    accepted (code = ES_SIM_STEP_DONE), either that step has been
    rejected (code = ES_SIM_STEP_REJECT).
    Init some parameters in case */
}


/*****************************************
*
*  function step_done_mos_udm
*
***********************************/

void step_done_mos_udm  (
#if defined(__STDC__) || defined(__cplusplus)
                        long  itra
                       )
#else
                        itra
                       )
long itra;
#endif
{
  /* A TRAN step has been accepted: Rotate states for instance*/
}


/*****************************************
*
*  function init_step_mos_udm
*
***********************************/

void init_step_mos_udm  (
#if defined(__STDC__) || defined(__cplusplus)
                        long  itra
                       )
#else
                        itra
                       )
long itra;
#endif
{
  /* Called prior to the first TRAN step */
}


/*--------------------------------------------------------------------
 mosuserx() "MOS model computation"

 purpose:       MOS model computaion.
 syntax:	mosuser2(itra,vvg,vv1,vv2,vvb)
 example call: 	mosuser2(itra,vvg,vv1,vv2,vvb);.
 arguments:     (long) itra is the transistor index.
                (double)vvg is the gate voltage referenced to 0.
                (double)vv1 is the voltage of node n1 referenced to 0.
                (double)vv2 is the voltage of node n2 referenced to 0.
                (double)vvb is the bulk voltage referenced to 0.
                All this voltages are computed with the sheet resistances  
                contribution.
 description:   This routine computes the drain-source current "courant" and
                the two diode currents "courbd" and "courbs" in the static
                part (for all the analysis) and the charges and/or
                capacitances for the  dynamic part (transient and AC analysis).
 comments:      see the notes below. 

IMPORTANT NOTE

The difficulty which can be found writing the MOS model in these
routines comes from the different meanings (i.e. electrical and
topological) of source and drain.

A MOS instantiation in the netlist has the following form:

Mx ND NG NS NB NAME W=10u L=1u AD=1u AS=2u PD=1p PS=2p NRD=1 NRS=1

In the simulator database all the above data is stored in the following
way (see also typmod.h) :

 trans[itra].nomt --> "Mx"
 trans[itra].ng   is the node NG "topological and electrical Gate"
 trans[itra].nb   is the node NB "topological and electrical Bulk"
 trans[itra].n1   is the node NS "TOPOLOGICAL source"
 trans[itra].n2   is the node ND "TOPOLOGICAL drain"
 trans[itra].ad   is the "TOPOLOGICAL" drain area.
 trans[itra].as   is the "TOPOLOGICAL" source area.
 trans[itra].pd   is the "TOPOLOGICAL" drain perimeter.
 trans[itra].ps   is the "TOPOLOGICAL" source perimeter.

In other words ad, pd and nrd are related to node ND, then to n2,
and as, ps and nrs are related to node NS, then to n1.

As far as voltages are concerned, 	vvg is the voltage on NG,
					vv1 is the voltage on n1,
					vv2 is the voltage on n2,
					vvb is the voltage on nb,

Furthermore, it is also common to have some MODEL parameters 
depending on topological meanings of drain and source. For instance
CGSO is related to node NS, then n1 for the SPICE levels, and
CGDO is related to node ND, then n2.

The difficulty then appears in writing the model, because the equations
depend on an electrical meaning of drain and source. 
The user is indeed, most of the time, willing to compute a current
flowing from the electrical drain to the electrical source depending
on the voltages of the electrical drain and source, as well as the
charge of the electrical drain and so on.
	
For the Bulk or the gate, no confusion is possible since the two
meanings are the same. 

For the drain and source however, care must be taken since the
simulator can not handle the "electrical" meaning. That means that
the final variables to be computed are TOPOLOGICAL variables :

 courant is the current flowing from node n2 to node n1 and has to be
     positive in this case. Unit is Ma.
 courbs is the current flowing from node n1 to node nb and has to be
     positive in this case (under normal bias courbs < 0). Unit is Ma.
 courbd is the current flowing from node n2 to node nb and has to be
     positive in this case (under normal bias courbd < 0). Unit is Ma.

 for XQC >= 0.5e0   --->   capacitance model
 cg1 is the gate to n1 capacitance.   Unit is pF.
 cg2 is the gate to n2 capacitance.   Unit is pF.
 cb1 is the bulk to n1 capacitance.   Unit is pF.
 cb2 is the bulk to n2 capacitance.   Unit is pF.
 cgb is the gate to bulk capacitance. Unit is pF.

 for XQC <= 0.5e0   --->   charge model
 TY->q11 is the charge attached to node n1. Unit is pC.
 TY->q22 is the charge attached to node n2. Unit is pC.
 TY->qg  is the charge attached to gate.    Unit is pC.
 and the bulk charge qb = -TY->q11 - TY->q22 - TY->qg

That is why the mosuserx() routines can be structured in the same
following way:

    mosuserx()
    {
      conversion TOPLOGICAL-ELECTRICAL  (1)
      ELECTRICAL equations              (2)
      conversion ELECTRICAL-TOPOLOGICAL (3)
    }

    (1) the first conversion has to determine which of node n1 and node
	n2 is the electrical drain and source depending on the voltages
	and the MOS type.
    (2) With the extracted electrical voltages, computation of the drain
	source current, and all the other electrical values.
    (3) Then the user has to transform the computed values in topological
	ones. For instance the sign of IDS has to be chosen, IBD has to
	be computed using either T->ad or T->as and so on.

The routine mosuser1() is fully commented to help the user. Refer also
to typmod.h and to the example usermod_example.c

NOTE : sign conventions.

	For the static currents see before.
	All the capacitances are positive numbers.
        Dynamic currents are computed as d(qxx)/time_step, and the
        convention sign is that the dynamic current is positive
        when it flows from the component toward the pin: for
        instance, if the dynamic current d(q11)/time_step enters
        the component from pin 1, then q11 should be negative.

     : Operating point information

       The global variable "vt" must used to store the real
       threshold voltage, as well as the global variable "vdss" to
       store the saturation voltage, since these values are displayed
       in the operating point information table;
       it is also possible to display any local variable used in
       the evaluation of the model in the operating point table:
       just use for that routine

          mosacop(itra,str,val)
          long itra;
          char *str;
          double val;

          where 'itra' is the index of the device,
                'str' is the character string to display, and
                'val' its value.


--------------------------------------------------------------------*/

/*****************************************
*
*  function mosuser1
**********************************/
 /*Variable definition*/
void mosuser1  (MOSARGU)
{
    double v1,v2,vg,vds,vs,vd,vdssat,vp,alpha,phisa,auxphisat,gate_charge,ypisilon,e2,f,fprime,ftwoprime;
    double ug,signphisa,phisa2,alpha1,qba,phif,qf,qis,qr,qid,qmin,qo,epsilon,ucrit,n,ncoxphit;
    double delta_l,leq,qidleq,xi1,xi2,qrleq,qi,q1,q2,qb,qg,qd,qs,x,xx1,sigma,mueff,betaeff,aplhatheta;
    double x1,vdsnovo,u2,x2,current,wn2,zn2,temp32,en2,y22;
    double u1,wn1,zn1,temp3,y2,en1,q1q1,q2q2,q1q1q1,q2q2q2,qd1,qd2,qd3;    
    double phisaoverphit, gammasquare;
    
    

    register struct S_tytra *T = &(trans[itra]) ;
    register struct S_tygeo *TY = &(trageo[itra]) ;
    register struct S_tymod *M = &(modmos[T->imo]) ;


     /*Voltage acquisition*/
     vg = vvg - vvb; v1 = vv1 - vvb; v2 = vv2 - vvb;
          
IF (M->noup == 'P' )
    {
      /* PMOS */
      vg = -vg; v1 = -v1; v2 = -v2;
    }
    
    vds =  fabs ( v2 - v1 ) ; /* the Drain-source voltage */
    vs = v1;
    IF (v1 > v2 ) vs = v2;   /* the source-bulk voltage*/

    /*Drain voltage Definition*/
    vd = vds + vs;
    

    gammasquare = M->p3 * M->p3;
   
    
   
    
    /**************************************************/
    /*Begin algorithm for evaluate phisa*/    
    alpha=-M->p3*sqrt(M->mktsurq);    
    phisa=0;
    ug=vg-M->p13; //M->p13 is VFB    
    {        
      if (ug<alpha)   phisa = - 2 * M->mktsurq * log( ug / alpha );	             
	             
      if (ug > M->mktsurq)  
	   {
             auxphisat=1+4*(ug-M->mktsurq)/(gammasquare);
             phisa=ug+(gammasquare/2)*(1-sqrt(auxphisat));             
           } 
     }    
	
     	if (ug>0)  phisa = ug<phisa ? ug : phisa; 
	  
	else  phisa = phisa>ug ? phisa : ug;   

 
 
     /*Iterative loop:repeat until abs(f)<10 ^ -12*/
      do {        
	gate_charge = (ug - phisa);
	
	e2 = 0;
	
	ypisilon = - phisa / M->mktsurq;
	
	if (ypisilon>-30)    e2=exp(ypisilon);    

	f = gate_charge * gate_charge / (gammasquare) - M->mktsurq * (e2-1) - phisa;

	fprime = e2 - 2 * gate_charge / (gammasquare) - 1;

	ftwoprime = 2 / (gammasquare) - (e2) / (M->mktsurq);

	phisa = phisa - f / (fprime - (f * ftwoprime) / (2 * fprime) );
	} while (fabs(f) >= 0.000000000001);     
	
  	
	/*******************************************************************/
	
	
	signphisa = phisa>0 ? 1: -1;/*signal of phisa*/
	if (phisa==0) signphisa=0;
	
		
	/*****************************************************************/
	/*Slope factor*/
	phisa2=fabs(phisa);
	if (phisa2<=0.00008)	
	
	{
	phisa2=-0.00002008;
	n=1+(M->p3*(1-safexp(-(phisa2)/M->mktsurq)))/(-2*safesqrt((phisa2)+M->mktsurq*(safexp(-(phisa2)/M->mktsurq))-M->mktsurq));
	}
	else 
	{
	n=1+(M->p3*(1-safexp(-(phisa)/M->mktsurq)))/(2*signphisa*safesqrt((phisa)+M->mktsurq*(safexp(-(phisa)/M->mktsurq))-M->mktsurq));
	}
	/****************************************************************/
	
	/*Pinch-off voltage*/
	phisaoverphit = safexp(-phisa / M->mktsurq) ;
	phif = M->p5;
	vp = phisa - 2 * phif - M->mktsurq * (1 + log (n / (n-1) ) );
	
	/*DIBL coeficient - SIGMA*/
        sigma = M->p4/T->ld/T->ld;
	
	/*Pinch-off Voltage*/
        vp = vp + sigma / n * (vd + vs);
	
	/*Definition of pinch-off charge - ncoxphit*/
        ncoxphit = n * M->cox *M->mktsurq;


    
    /*Source Charge Calculation (Algorithm to solution of the transcendental equation)*/
    u1 = (vp - vs)/M->mktsurq + 2;

    if (u1 <-30)
    		{
		u1 = -30;
		wn1 = 1e-10;
                }

    else if (u1 <= 0.6)
	    {
	    x1 = exp(u1-1);
	    wn1 = x1 * (1 + 4 * x1 / 3) / (1 + x1 * (7 / 3 + 5 * x1 / 6));
	    }
    	else
	   {
	    wn1 = (u1-1) - 24 * (((u1-1) + 2) * (u1-1) - 3) / ((7 * (u1-1) + 58) * (u1-1) + 127);
	    }
	 /*iteration ONE*/
    zn1 = (u1-1) - wn1 - log(wn1);
    temp3 = 1 + wn1;
    y2 = 2 * temp3 * (temp3 + 2 * zn1/3) - zn1;
    en1 = zn1 * y2 / (temp3 * (y2 - zn1));
    wn1 = wn1 * (1 + en1);

    
    qf = wn1+1;
    /*qf = forward inversion charge density*/
    qf = -qf * ncoxphit;
    /*qis = source inversion charge density*/
    qis = qf + ncoxphit;
	
	   
    
    /*Longitudinal critical field calculation*/
    ucrit= M->ucrit;

    /*qo */
    qo = n * M->cox * T->ld * ucrit;

    
    epsilon = ncoxphit/qo;

    /*Minimum charge = inversion density at the drain end of the channel*/
    qmin = 2 * epsilon * qis * (1 - qis / (2 * epsilon * qo)) / (1 - (qis - ncoxphit) / qo + safesqrt(1 - 2 * (qis-ncoxphit) / qo + (ncoxphit / qo) *(ncoxphit / qo)));

    /*Saturation Voltage*/
    vdssat = M->mktsurq * ((qmin - qis)/ncoxphit + safelog(qis / qmin));

    
    /*Calculation of effective drain voltage*/
    vdsnovo = (vds)/(pow(1+pow(vds/vdssat,4),0.25));



    /*Equivalent channel*/
    delta_l = M->lambda * M->p10 * log(1 + (vds - vdsnovo) / (M->p10 * ucrit));/*p10 is lc*/
    leq = T->ld - delta_l;/*equivalent length*/


    /*Inversion Drain Charge Calculation*/
   u2 = (vp - vdsnovo - vs) / M->mktsurq + 2;
    if (u2 <-30)
    		{
    		wn2=1.0e-10;
		u2=-30;
		}

       else if (u2 <= 0.6)
    {
	    x2 = exp(u2-1);
	    wn2 = x2 * (1 + 4 * x2 / 3) / (1 + x2 * (7 / 3 + 5 * x2/6));
    }
    else
	    {
	    wn2 = (u2-1) - 24 * (((u2-1) + 2) * (u2-1) - 3) / ((7 * (u2-1) + 58) * (u2-1) +127);
	    }

    /*iteration ONE*/
    zn2 = (u2-1) - wn2 - log(wn2);
    temp32 = 1 + wn2;
    y22 = 2 * temp32 * (temp32 + 2 * zn2/3)-zn2;
    en2 = zn2 * y22 / (temp32 * (y22 - zn2));
    wn2 = wn2 * (1+en2);

    qrleq = wn2+1;
    /*qrleq = reverse inversion charge density*/
    qrleq = -qrleq * ncoxphit;
    /*qidleq = drain inversion charge density*/
    qidleq = qrleq + ncoxphit;
    /*end of drain charge calculation*/
    
    
    /***********************************************/
    /* TOTAL CHARGES WITHOUT EFFECTS*/
    alpha1 = qrleq / qf;      
    qi = T->wd *leq*((2*(1+alpha1+alpha1*alpha1))*(qis-ncoxphit)/(3*(1+alpha1))+ncoxphit); /*Inversion Charge*/
    qd=T->wd*leq*((4+8*alpha1+12*alpha1*alpha1+6*alpha1*alpha1*alpha1)*(qis-ncoxphit)/(15*(1+alpha1)*(1+alpha1))+ncoxphit/2); /*Drain Charge*/
    qs=T->wd*leq*((6+12*alpha1+8*alpha1*alpha1+4*alpha1*alpha1*alpha1)*(qis-ncoxphit)/(15*(1+alpha1)*(1+alpha1))+ncoxphit/2); /*Source Charge*/
    qba=(signphisa)*T->wd*leq*(-M->p3*M->cox*safesqrt(phisa+M->mktsurq*(phisaoverphit-1)));
    //qba=(signphisa)*(safesqrt(phisa+phit*(safexp(-phisa/phit)-1)));
    qb=-((n-1)/(n))*qi+qba; /*Bulk Charge*/
    qg=-qi-qb;
	
     
     /**********************************************/
     /*Drain Current */
	{	 	
	xi1 = (qf * qf - qrleq * qrleq) / (2 * n);
	/*To avoid descontinuity to Vds=0 */
	xi2 = 1/(1 + sqrt((qf - qrleq)*(qf - qrleq)+ (1/10)*(1/10))*(1/qo));
	mueff=M->mu0/(1-M->p17*(qb+0.5*qi));//APLHATHETA is p17
        betaeff = (mueff * T->wd) / (M->cox * leq);
        current = (betaeff * xi1 * xi2);
	
         
	/*Conversionlectrical-topological*/
	/*NMOS*/
	if (M->noup=='N')
	{
	courbs = 0; courbd = 0;
		if (v2>v1)
		{
		courant = current*1.0e3;/*value in mA*/
		}
		else
		{
		courant = -current*1.0e3;/*value in mA*/
		}
	}
	/*PMOS*/
	if (M->noup=='P')
	{
	courbs = 0; courbd = 0;
		if (v1>v2)
		{
		courant = current*1.0e3;/*value in mA*/
   		}
		else
		{
		courant = -current*1.0e3;/*value in mA*/
   		}
	}

         }
 IF (M->xqc <= d0p5 )
     {
     
      
   x = current / (T->wd * M->p12) ;/*p12 is vmax*/
   xx1 = (T->ld*current) / (M->p12) ;/*p12 is vmax*/   

    q1 = qf + x;
    q2 = qrleq + x;
    q1q1=q1*q1;
    q2q2=q2*q2;
    q1q1q1=q1q1*q1;
    q2q2q2=q2q2*q2;

    /*Inversion Charge*/
    qi = T->wd * leq * ((2*(q1q1+q1*q2+(q2q2))/(3*(q1+q2)))+ncoxphit) - xx1;


    /*Bulk Charge equation*/
    qb = ((-n + 1) * qi)/n + qba;

    /*Drain Charge equation*/
    qd1=T->wd*(leq*leq/T->ld);
    qd2=6*(q2q2q2)+12*(q2q2)*q1+8*q2*(q1q1)+4*(q1q1q1);
    qd3=(15*(q1+q2)*(q1+q2));
    qd=qd1*(qd2/qd3+ncoxphit*0.5)-xx1*0.5;


    /* Source Charge*/
    qs = qi-qd;
     /*Gate Charge equation 3.73*/
    qg=-qb-qi;

/*******************************************************************************/
          /*Charge - Conversion electrical-topological*/
      /*NMOS*/
	if (M->noup=='N')
		{
		cg1 = dzero; cg2 = dzero; c1b = dzero; c2b = dzero; cgb = dzero;
		if (v2>v1)
		{
		/*Case of Charge control */
        	TY->q11 =1.0e+12 * qs ;/*charge attached to node n1 in pC*/
		TY->q22 =1.0e+12 * qd ;/*charge attached to node n2 in pC*/
		TY->qg =1.0e+12 * qg;/*charge attached to node ng in pC*/
		}
		else
		{
		/*Case of Charge control */
        	TY->q11 =1.0e+12 * qd ;/*charge attached to node n1 in pC*/
		TY->q22 =1.0e+12 * qs ;/*charge attached to node n2 in pC*/
		TY->qg =1.0e+12 * qg;/*charge attached to node ng in pC*/
		}

		}


	if (M->noup=='P')
		{
		cg1 = dzero; cg2 = dzero; c1b = dzero; c2b = dzero; cgb = dzero;
		if (v2>v1)
		{
		/*Case of Charge control */
        	TY->q11 =-1.0e+12 * qs ;/*charge attached to node n1 in pC*/
		TY->q22 =-1.0e+12 * qd ;/*charge attached to node n2 in pC*/
		TY->qg =-1.0e+12 * qg;/*charge attached to node ng in pC*/
		}
		else
		{
		/*Case of Charge control */
        	TY->q11 =-1.0e+12 * qd ;/*charge attached to node n1 in pC*/
		TY->q22 =-1.0e+12 * qs ;/*charge attached to node n2 in pC*/
		TY->qg =-1.0e+12 * qg;/*charge attached to node ng in pC*/
		}
		
		}
}

}
/*--------------------------------------------------------------------
 mosuser() "main routine for UDM "

 purpose:      This routine has two purposes:

                - to deal with access resistances. This means that it
                  computes from the original voltages given by the simulator
                  the actual internal voltages which take into account the
                  access resistances.

                - then to select the relevant model routine depending on the
                  level.

 syntax:        mosuser(itra,vvg,vv1,vv2,vvb);
 example call:  CALLED INTERNALY BY THE SIMULATOR.
 arguments:     itra : transistor index.
                vvg  : gate voltage.
                vv1  : voltage of node n1
                vv2  : voltage of node n2
                vvb  : bulk voltage.
 comments:      THIS ROUTINE SHOULD USUALLY NOT BE MODIFIED except of the
                access resitances computation.
--------------------------------------------------------------------*/
void mosuser  (MOSARGU)
{   register struct S_tytra *T = &(trans[itra]) ;
    register struct S_tygeo *TY = &(trageo[itra]) ;
    register struct S_tymod *M = &(modmos[T->imo]) ;

    switch(M->niv)
    {
      case 21 : mosuser1(itra, vvg, vv1, vv2, vvb USE_SPROC) ; break ; /* level = 21 */
      //case 22 : mosuser2(itra, vvg, vv1, vv2, vvb USE_SPROC) ; break ; /* level = 22 */
  /*  case 23 : mosuser3(itra, vvg, vv1, vv2, vvb USE_SPROC) ; break ;  and so on */
      default: break ;
    }
//courant=courant;

}
  


/******************************************************************************/
/************************  Gudm_step_done_mos_user()  *************************/
/******************************************************************************/

void Gudm_step_done_mos_user  (
#if defined(__STDC__) || defined(__cplusplus)
                              long  itra,
                              double * tabS
                             )
#else
                              itra,
                              tabS
                             )
long itra; double *tabS;
#endif
{
}

/******************************************************************************/
/************************  Gudm_init_step_mos_user()  *************************/
/******************************************************************************/

void Gudm_init_step_mos_user  (
#if defined(__STDC__) || defined(__cplusplus)
                              long  itra,
                              double * tabS
                             )
#else
                              itra,
                              tabS
                             )
long itra; double *tabS;
#endif
{
}

/******************************************************************************/
/***************************  Gudm_call_mos_user()  ***************************/
/******************************************************************************/

void Gudm_call_mos_user  (
#if defined(__STDC__) || defined(__cplusplus)
                         long  itra,
                         long * tabNoe,
                         double * tabVN,
                         double * tabS SPROC
                        )
#else
                         itra,
                         tabNoe,
                         tabVN,
                         tabS
                        )
long itra;
long *tabNoe;
double * tabVN;
double *tabS;
#endif
{
  /* Called only in Gudm mode: evaluate the device: make call to:
     Gudm_Istat(), Gudm_Q(), Gudm_conductance() and Gudm_capacitance(). */
}


/******************************************************************************/
/****************************  Gudm_mos_user_AC()  ****************************/
/******************************************************************************/

void Gudm_mos_user_AC  (
#if defined(__STDC__) || defined(__cplusplus)
                       long  itra,
                       long * tabNoe,
                       double * tabVN,
                       double * tabS SPROC
                      )
#else
                       itra,
                       tabNoe,
                       tabVN,
                       tabS
                      )
long itra;
long *tabNoe;
double * tabVN;
double *tabS;
#endif
{
  /* Case of non-static: variable M->nqs not set to 1 (0 is the default).
     The device has been already linearized around 
     the DC OP point, remove here conductance/capacitances added in DC,
     and add frequency-dependent terms in the matrix, if necessary, via routines
     Gudm_conductance() for real part, and Gudm_capacitance(), for imaginary part. */
}

/******************************************************************************/
/**************************  Gudm_mos_user_NOISE()  ***************************/
/******************************************************************************/

void Gudm_mos_user_NOISE  (
#if defined(__STDC__) || defined(__cplusplus)
                          long  itra,
                          long * tabNoe,
                          double * tabVN,
                          double * tabS SPROC
                         )
#else
                          itra,
                          tabNoe,
                          tabVN,
                          tabS
                         )
long itra;
long *tabNoe;
double * tabVN;
double *tabS;
#endif
{
  /* Call here Gudm_noise_src: other Gudm functions (Gudm_Istat,
     Gudm_conductance....) are disabled (but can be called). */
}

/******************************************************************************/

